' FILE				: EPS_Converter.vbs
' VERSION			: 2.50
' DATE				: 28/01/2021
' DESCRIPTION		: Converts EPS to hpgl or DXF
'----------------------------------------------------------------
Dim versionnumber
Dim Startx,starty,Ax,Ay,Bx,By,Lx,Ly,Kx,Ky,beziervals
Dim lastpntx,lastpnty,pc,grainmm,grainunits,prevKx,prevKy
Dim commentslevel,resourcecontainer,textcontent,myarray(5000000)
Dim rememberarray(20),rememberarraycounter,remembertextline
Dim textatend
Dim mytxtline,convertpointstounits,counter
Dim myarraycounter,matrixx,matrixy,supportbeziers,converttocircle
Dim stepdistance,intermediatepoints,distbetwpnts,regmarksname
Dim actualgrainunits,P,V,pivalue,distancestartstop,oldtargetx
Dim oldtargety,rotationval
Dim dashoff,dashon,applyrotationtoall,mediasizex,mediasizey
Dim xlocation,ylocation,cutter,startopos,MARKER_X_N,startoposmark
Dim oposarrayx,oposarrayy,oposiswrittenmreg,regmarksatend,hcommand
Dim MARKER_X_DIS,MARKER_Y_DIS,pdx,MARKER_X_SIZE,origxlocation,origylocation
Dim lastaction,applyrotationtoallset
Dim exportdebugfiles,inputfolderroot,outputfolderroot,finaloutputfile,debugfolderroot
Dim smallestx,smallesty,postfilename,invertcounter,write5,detectpu,largestx
Dim largesty,debugfile,usetempfolder,tempfolderroot,previousx,previousy
Dim previouscircle,markrotation,Remembermatrixx,Remembermatrixy
Dim Remembermatrixxconsumed,Remembermatrixyconsumed,add2textcontent,theoutputfile
Dim insidesheet,previousoperation,circlestring
'Dim pointoutsidesheet,memorizeorientation,rectclip,cliparray,previouswrittenlayer
Dim finalfilename5,scriptlocation,dxfheader,dxfheaderfile
Dim figuresaftercomma,supportMK,lastsupportMK,MKcounter,errorval,errorfile,cmfctr,layerselection,detectendpagesetup,defaultmatrix
Dim previousxkona,previousykona,konaal4x1,konaal4y1,konaal4x2,konaal4y2,konacounter,argulist,dragfile,BeginPageSetup,PageSetupdef,BeginPageSetupval,cutoffsumma
Dim optionalargs,summafirstline,summaspecialload,cutteroption,scriptpath,allowdelete,contnode,marksnode,xmlcirclecounter,rememberxmlcircle,lastdot,circsize,xmlcirclecountertotal,xmlmarkx,xmlmarky,xmlmarkxmax
Dim errorhandling,pucounter,axisstring,transx,transy,allowaxischange,toolforce,toolspeed,cutteroffset,layerlist
versionnumber="2.48"
SetLocale("en-ca")		' ignore regional settings
'---------------------------------------------------------------
'Setup variables
'---------------------------------------------------------------

supportbeziers=False	' By default beziers are converted to a 
						' series of lines
						' hpgl2 supports beziers (set to true). 
						' hpgl/plt doesn't support this (set to False)
						
grainmm=0.5				' Default grain for conversion bezier to
						' lines
						
commentslevel=0			' Level of comments (0=little comments, 
						' 9=all comments)
						
regmarksname="8"		' when cutter registration marks are 
						' written by Asanti they are always in 
						' color black. this must be changed in
						' the script.

usetempfolder=False		'When set to true, the final file is first 
						'written locally in a temp folder.
						
toolforce="50"			'urrently only used For Roland
						'!FSn;
						'n: tool force=cutting force (unit: gf) INTEGER (20 to 600)
						'set to "" if toolforce doesn't need to be included
								

toolspeed="30"			'urrently only used For Roland'
						'VSn;
						'n:tool Speed=cutting speed (unit: cm/sec) must be REAL (1 to 105)
						'set to "" if toolspeed doesn't need to be included
						
						
cutteroffset="0.250"			'urrently only used For Roland'
						'!ST1,m;
						'specify offset=blade offset (unit: micron ) must be INTEGER (0 to 1000)
						'set to "" if cutteroffset doesn't need to be included


'---------------------------------------------------------------
'Fixed variables
'---------------------------------------------------------------

''pointoutsidesheet=""
''memorizeorientation=""
cutter=""				'name of the cutter
startopos=False			'only for summa
applyrotationtoall=0	'default rotation of imageblock on sheet
applyrotationtoallset=False
myarraycounter=0
textcontent=""
currentmatrix=""
lastpntx=0
lastpnty=0

resourcecontainer=""
Const ForReading=1, ForWriting=2, TristateFalse=0
pivalue=3.14159265358979323846264
rotationval="0"
''rectclip=""

errorhandling="stdout"
layerlist=Array()
dashoff=0
dashon=0
pux=""
puy=""
lastdot=""
MARKER_X_N=0
MARKER_X_DIS=0				
MARKER_Y_DIS=0
oposarrayx=""
oposarrayy=""
pdx=""
MARKER_X_SIZE=0
oposiswritten = True
smallestx=0
largestx=0
largesty=0
smallesty=0
postfilename=""
write5=false
''cliparray=False
lastaction=""
''previouswrittenlayer=""
markrotation="0"
Remembermatrixx=0
Remembermatrixy=0
Remembermatrixxconsumed=0
Remembermatrixyconsumed=0
cmfctr=100
layerselection="CN "
detectendpagesetup=False
defaultmatrix=false
previousxkona=0
previousykona=0
konaal4x1=""
konaal4y1=""
konaal4x2=""
konaal4y2=""
argulist=""
axisstring="000" 'Used for function changeaxis
allowaxischange=False
circlestring=""
dragfile=False
dxfheader=false
supportMK=False 'Set to True if cutter supports MK command (e.g. Comagrav cutter) for placement regmarks
lastsupportMK=""
MKcounter=1
regmarksatend=False	'set to true if regmarks always need to be
					'placed at the end of the file
textatend=""
cutoffsumma=False
summaspecialload="OPOS"

allowdelete="True"
xmlcirclecounter=0
xmlcirclecountertotal=0
xmlcirclepartcounter=0
pucounter=1

errorval=""
BeginPageSetup=""
BeginPageSetupval=""
xmlmarkx=""
xmlmarky=""
xmlmarkxmax=""

Set fso = CreateObject("Scripting.FileSystemObject")
Set objShell = CreateObject("Wscript.Shell")
Set stderr = fso.GetStandardStream (2)

scriptlocation = Wscript.ScriptFullName
scriptpath = Replace(scriptlocation,WScript.ScriptName,"")



'---------------------------------------------------------------
'Posterror function
'---------------------------------------------------------------


Function posterror(errmes)
    If errorhandling<>"stdout" then
    	MsgBox errmes
  			else
   		 		stderr.WriteLine "[EPSConverter] SNO: "&errmes
  	end if

End function


'---------------------------------------------------------------
'Read arguments
'---------------------------------------------------------------
On Error Resume next
Set ScriptArgument = Wscript.Arguments

epsfilelocation= ScriptArgument(0)	'the original eps file location
If Err.Number>0 Then
	
	posterror("The script EPS_Converter was started from finishing hub but no arguments where found. "& Err.Description&". The script is not executed with success.")
	WScript.Quit 2
	
	Else
		
		If fso.FileExists(epsfilelocation) Then
			Else
				If Left(epsfilelocation,5)="\\169" Then
					posterror("Could it be that Asanti Server is started on an invalid ip address. Invalid ip addresses start with 169.254? This can be caused by disconnected network cards that are not disabled. EPS File is Not found: "&epsfilelocation)
						Else
							posterror("EPS File is Not found: "&epsfilelocation)
				End If
		
		
		
			WScript.Quit 2
		End if
End If

testarguments= ScriptArgument(5)
If Err.Number>0 Then
	'Err.clear

	conflocation=Replace(scriptlocation,"EPS_Converter.vbs","conf.xml")
	
	If (fso.FileExists(conflocation)) Then	'read xml configuration file if available (only used if script is called without arguments)
	
		Set MSXML = CreateObject("Microsoft.XMLDOM") 
		MSXML.async = False 
		MSXML.load(conflocation)
		set node=MSXML.selectSingleNode("//XML/Appl")
		
		if not (node is Nothing) Then
				dragfile=True
				Rememberpathloc=ScriptArgument(0)
				
				ReDim ScriptArgument(7)
				ScriptArgument(0)=Rememberpathloc
				xmloutputfile = node.getAttribute("output")
			
				
				filesplit=Split(xmloutputfile,";")
		
		
				If UBound(filesplit) > 0 Then
					ScriptArgument(1)=filesplit(0)
					usetempfolder=True
						Else
							ScriptArgument(1)="."
				End If
				ScriptArgument(2)=node.getAttribute("filetypes")
				ScriptArgument(3)=node.getAttribute("pen")
				ScriptArgument(4)=node.getAttribute("units")
				ScriptArgument(5)=node.getAttribute("accuracy")
				ScriptArgument(6)=node.getAttribute("debug")
				ScriptArgument(7)=node.getAttribute("optional")
			
				Err.Clear
				Else
						posterror("The script"&" was started but not enough arguments where found. "& Err.Description&". The script is not executed with success.")
		End if
		
		Else
		posterror("The script"&" was started but not enough arguments where found. "& Err.Description&". The script is not executed with success.")
		WScript.Quit 2
	End if

	
End If

argulist=ScriptArgument(2)&" "&ScriptArgument(3)&" "&ScriptArgument(4)&" "&ScriptArgument(5)

Select Case ScriptArgument(3)		' registration mark name. This is needed because Asanti 
									' puts a registration mark as black in the cut file.
	Case ""
		regmarksname="8"
	Case Else
		regmarksname=ScriptArgument(3)
End Select

Select Case ScriptArgument(4)		' conversion postscript points to 
									' units used by cutter
	Case ""
		units=0.025
	Case Else
		units=ScriptArgument(4)
End Select
unitsv=1/units

Select Case ScriptArgument(5)		' grain used when convert 
									' beziers to lines
	Case ""
		
	Case Else
		grainmm=ScriptArgument(5)
End Select


If units > 0.1 then
	figuresaftercomma=3
	Else
	figuresaftercomma=2
End If


Select Case ScriptArgument(2)		' file extention
	Case "gbr(Kuris)"
		extentionval=".gbr"
		regmarksatend=False
		cutter="Kuris"
		
	Case "cff2"
		extentionval=".cf2"
		regmarksatend=False
		cutter="cf2"
		
	Case "plt"
		extentionval=".plt"
		regmarksatend=True
		
	Case "hpgl"
		extentionval=".hpgl"
	Case "plt(First Regmarks)"
		extentionval=".plt"
		regmarksatend=False
		
	Case "roland"
		extentionval=".plt"
		regmarksatend=False		
		cutter="roland"		
		errorhandling="stdout"
		axisstring="110"
		allowaxischange=True

		
	Case "plt(Comagrav)"
		extentionval=".plt"
		regmarksatend=False
		figuresaftercomma=0
		cutter="Comagrav"
		cmfctr=1
	Case "plt(KONA.AL4)"
		extentionval=".plt"
		regmarksatend=False
		cutter="konaal4"
		cutteroption="AL4"
		figuresaftercomma=0
		
	Case "plt(KONA.AL3)"
		extentionval=".plt"
		regmarksatend=False
		cutter="konaal4"
		cutteroption="AL3"
		figuresaftercomma=0

	Case "plp(Comagrav)"
		extentionval=".plp"
		regmarksatend=False
		figuresaftercomma=0
		supportMK=True
		cmfctr=1
		cutter="Comagrav"
		layerselection=""
	Case "hpgl2"
		supportbeziers=True
		extentionval=".hpgl"
	Case "hpgl_summa"
		extentionval=".hpgl"
		cutter="summa"
		oposiswritten = False
	Case "hpgl_summa_barcode"
		extentionval=".hpgl"
		cutter="summa"
		postfilename="0"
		oposiswritten = False

	
	Case "hpgl_summa_cutoff"
		extentionval=".hpgl"
		cutter="summa"
		oposiswritten = False
		cutoffsumma=True
		
	Case "hpgl_summa_barcode_cutoff"
		extentionval=".hpgl"
		cutter="summa"
		postfilename="0"
		oposiswritten = False
		cutoffsumma=True
		
	Case "oxf"
		supportbeziers=True
		extentionval=".oxf"
	Case "dxf"
		extentionval=".dxf"
	Case "dxf(beziers)"
		extentionval=".dxf"
		supportbeziers=True
		dxfheader=True
		usetempfolder=True
		
	Case "dxf(multicam)"
		extentionval=".dxf"
		supportbeziers=False
		dxfheader=False
		cutter="multicam"
		usetempfolder=True


		
		
	Case "xml(Jwei)"
		'extentionval=".jwcut"
		extentionval=".xml"
		supportbeziers=True
		cutter="Jwei"
		usetempfolder=True

	Case Else
			WScript.Quit 1
		extentionval=".hpgl"
		errorval="Wrong file format ("&ScriptArgument(2)&") set in script arguments. Using fallback HPGL."
End Select

If ScriptArgument(1)="." Then	'when this argument is set to ".". the cut file must be exported on the same location as the eps.
	theoutputfile= Left(ScriptArgument(0), (InstrRev(ScriptArgument(0), "\")))
		Else
	
		theoutputfile=ScriptArgument(1)
		xmloutputfile=ScriptArgument(1)
	
		filesplit=Split(theoutputfile,";")
	
		If UBound(theoutputfilesplit)>0 Then
			theoutputfile=filesplit(0)
			usetempfolder=True
		End if
		
End If

'---------------------------------------------------------------
'Set export filelocation
'--------------------------------------------------------------

'ROOT input folder:

inputfolderroot=Left(ScriptArgument(0), (InstrRev(ScriptArgument(0), "\")))


Splittesting=Split(inputfolderroot,"\testing")

If scriptpath=inputfolderroot Or UBound(Splittesting)=1 Then
	allowdelete="False"
	
End If



inputfilename=Replace(ScriptArgument(0),inputfolderroot,"")
debugfolderroot=inputfolderroot&"debug\"
tempfolderroot=inputfolderroot&"temp\"

'set tempfolderroot location if UNC path
If Left(theoutputfile,1)<>"." And dragfile=False Then
	usetempfolder=True
	Set oShell = CreateObject("Wscript.Shell")
	appdata = oShell.SpecialFolders("AppData")
	sXMLFile = appdata
	'sXMLFile = "c:\temp"
	tempfolderroot = sXMLFile&"\Agfa\epsconvert\"
End if

'ROOT output folder:
outputfolderroot=theoutputfile&"\"

'Final exported file without extention:
finaloutputfile=replace(inputfilename,".eps",postfilename)
errorfile=outputfolderroot & "ERR_"&finaloutputfile&".log"

'Final exported file with path:
filelocation=outputfolderroot & finaloutputfile & extentionval

'Final reversed exported file without extention:
finaloutputfile5=replace(inputfilename,".eps","5")

'Final reversed exported file with path:
filelocation5=outputfolderroot & finaloutputfile5 & extentionval

'Debug files:
debugfilefinal=debugfolderroot&finaloutputfile&"_FINAL"&extentionval
debugfilefinal5=debugfolderroot&finaloutputfile5&"_FINAL"&extentionval
debugfiletracing=debugfolderroot&finaloutputfile&"_DEBUG"&extentionval
debugfilenoopos=debugfolderroot&finaloutputfile&"_FINALNO_OPOS"&extentionval
debugfilenoal4=debugfolderroot&finaloutputfile&"_FINALNO_AL4"&extentionval
debugfilenoopos5=debugfolderroot&finaloutputfile5&"_FINALNO_OPOS"&extentionval

'---------------------------------------------------------------
'Create debug folder and copy original eps
'---------------------------------------------------------------

Select Case LCase(ScriptArgument(6))		' export debug files

	Case "true"
		Err.Clear

		If  Not fso.FolderExists(debugfolderroot) Then
			Set rfa = fso.CreateFolder(debugfolderroot)
			If  Not fso.FolderExists(debugfolderroot) Then
				posterror("Debug folder cannot be created at "&debugfolderroot&". Error: "&Err.Description&". Please turn off the debug flag.")
			End if
		End if
		
		exportdebugfiles=True
		Set MyFileq = fso.GetFile (epsfilelocation)
		MyFileq.Copy debugfolderroot&finaloutputfile&"_ORIG.eps"
		
	Case Else
		exportdebugfiles=False

End Select
'---------------------------------------------------------------
'read optional arguments
'---------------------------------------------------------------
Err.Clear
On Error Resume Next
optionalargs=ScriptArgument(7)
optionalargssplit=Split(optionalargs," ")
If Err.Number<>0 Then
	'MsgBox Err.Description
	Err.Clear
	optionalargs=""
	Else
		optionalcounter=0
	
		Do While optionalcounter<UBound(optionalargssplit)+1
			curoptionaltest=LCase(optionalargssplit(optionalcounter))
			curoptional=optionalargssplit(optionalcounter)
			Select Case Left(curoptionaltest,10)
				Case "cutoffsumm"
					cutoffsumma=True
				Case "special_lo"	
					'expected argument should look like SPECIAL_LOAD=OPOS
					summaspecialloadsplit=Split(curoptional,"=")
					summaspecialload=Replace(summaspecialloadsplit(1),"..",".")
			End Select
			
			optionalcounter=optionalcounter+1
		Loop	
End If


'---------------------------------------------------------------
'Create temp folder if needed
'---------------------------------------------------------------

If usetempfolder=True Then

		If  Not fso.FolderExists(tempfolderroot) Then
			Err.clear
			On Error Resume next
			Set rfa = fso.CreateFolder(tempfolderroot)
			If Err.Number<>0 Then
				posterror(Err.Description)
				WScript.Quit 2
			End If
			If  Not fso.FolderExists(tempfolderroot) Then
				posterror("Temp folder cannot be created at "&tempfolderroot&". Error: "&Err.Description&".")
			End if
		End if
End if
'---------------------------------------------------------------
'copy eps to temp folder if needed
'---------------------------------------------------------------

If usetempfolder=True Then
	Set MyFileq = fso.GetFile (epsfilelocation)

	If MyFileq.Size = 0 Then
		posterror("Eps created by Asanti has a size of "& MyFileq.Size&" KB. The EPS_Converter script cannot continue.")
		WScript.Quit 2
	End if

	Err.clear
	On Error Resume Next

	If allowdelete = "True" Then
	
		MyFileq.Copy tempfolderroot&inputfilename
		MyFileq.delete
		
			Else
				MyFileq.Copy tempfolderroot&inputfilename
	End If
		
	If Err.Number<>0 Then
		posterror("Failed to move eps file ("&epsfilelocation&") to temp directory ("&tempfolderroot&"): "&Err.Description&".")
		WScript.Quit 2
		Else 
		epsfilelocation=tempfolderroot&inputfilename
	End if
End if
'---------------------------------------------------------------
'Unit Conversions
'---------------------------------------------------------------
mmtopoints=2.83464567
convertpointstounits=unitsv/mmtopoints
grainunits=grainmm*unitsv
	
'---------------------------------------------------------------
'Functions to write debug files
'---------------------------------------------------------------			
				
Function createdebugfile	
		If (fso.FileExists(debugfile)) Then
			Set MyFilea = fso.GetFile(debugfile)
			On Error Resume next
			MyFilea.Delete
			Err.clear
		End If
End function		


Function createdebugfilenoal4	
		If (fso.FileExists(debugfilenoal4)) Then
			Set MyFilea = fso.GetFile(debugfilenoal4)
			On Error Resume next
			MyFilea.Delete
			Err.clear
		End If
End function		
		
		
		
Function createdebugfilenoal4_onerror
		If Err.Number>0 Then
			posterror("Createdebugfilenoal4_onerror: EPS_Converter has an access error to file "&debugfilenoal4)
			exportdebugfiles=False
			Err.Clear
			
		End If
End function	
				
Function createdebugfile_onerror
		If Err.Number>0 Then
			posterror("Createdebugfile_onerror: EPS_Converter has an access error to file "&debugfile)
			exportdebugfiles=False
			Err.Clear
		End If
End function				


'---------------------------------------------------------------
'Create files
'---------------------------------------------------------------

Err.Number=0

On Error Resume Next
If extentionval=".xml" Then
	Set xmlDoc = CreateObject("Msxml2.DOMDocument.6.0")
	xmlDoc.async = false
	Set stylePI = xmlDoc.createProcessingInstruction("xml","version=""1.0"" encoding=""UTF-8""")  
	xmlDoc.appendChild(stylePI)
	Set rootnode= xmlDoc.createNode(1,"jingwei_cut_job","")	
	xmlDoc.appendChild(rootnode)
	Set jobnode= xmlDoc.createNode(1,"job","")	
	rootnode.appendChild(jobnode)
	splitfinaloutputfile=Split(finaloutputfile,"_")
	If UBound(splitfinaloutputfile)>0 And Len(splitfinaloutputfile(0))=9 Then
		jobnode.setAttribute "id",splitfinaloutputfile(0)
	End if
			
	Set swnode= xmlDoc.createNode(1,"software","")	
	jobnode.appendChild(swnode)
	swnode.setAttribute "name","Asanti_EPS_Converter"
	swnode.setAttribute "version",versionnumber
	Set mednode= xmlDoc.createNode(1,"media","")	
	jobnode.appendChild(mednode)
	mednode.setAttribute "name","Unknown"
	mednode.setAttribute "material","Unknown"
	Set dimnode= xmlDoc.createNode(1,"dimensions","")	
	jobnode.appendChild(dimnode)
	dimnode.setAttribute "unit","mm"
	Set pathsnode= xmlDoc.createNode(1,"paths","")	
	rootnode.appendChild(pathsnode)
	pathsnode.setAttribute "unit","mm"
	Set marksnode= xmlDoc.createNode(1,"marks","")	
	rootnode.appendChild(marksnode)
	marksnode.setAttribute "unit","mm"

		Else
				If usetempfolder=True Then
					Set hpglfile = fso.CreateTextFile(tempfolderroot&finaloutputfile & extentionval, True)
					If Err.Number>0 Then
						posterror("EPS Converter can't write file "&tempfolderroot&finaloutputfile & extentionval&". " &err.Description)
					End if
					
					Else
						Set hpglfile = fso.CreateTextFile(filelocation, True)
				End if
End if

If Err.Number>0 Then
	posterror("EPS_Converter has an access error to file "&filelocation&". " &err.Description)
	Err.Clear
	WScript.Quit 2
	else
	If postfilename="0" Then
		If usetempfolder=True Then
			filename5=Replace(tempfolderroot&finaloutputfile & extentionval,"0"&extentionval,"5"&extentionval)
			finalfilename5=Replace(finaloutputfile & extentionval,"0"&extentionval,"5"&extentionval)
			else
			filename5=Replace(filelocation,"0"&extentionval,"5"&extentionval)
			
		End If
		Set hpglfile5 = fso.CreateTextFile(filename5, True)
		Else
	End if

	If exportdebugfiles=True Then

		'Debug file - final result
		debugfile=debugfilefinal
		createdebugfile
		If extentionval<>".xml" Then
			Set hpglfiledebug = fso.CreateTextFile(debugfile, True)
		End if
		createdebugfile_onerror
		
		'Debug file - final result + extra comments
		debugfile=debugfiletracing
		createdebugfile
		Set hpglfiledebug2 = fso.CreateTextFile(debugfile, True)
		createdebugfile_onerror
	
		'Debug file - final result without AL4 code
		If cutter="konaal4" then
			
			createdebugfilenoal4
			
			Set hpglfiledebugnoal4 = fso.CreateTextFile(debugfilenoal4, True)
			createdebugfilenoal4_onerror
		End if
		
		'Debug file - final result without opos marks
		If cutter="summa" then
			debugfile=debugfilenoopos
			createdebugfile
			Set hpglfiledebugnoopos = fso.CreateTextFile(debugfile, True)
			createdebugfile_onerror
		End if	
		
		'Debug file - final result with reversed cutting
		If postfilename="0" Then
			debugfile=debugfilefinal5
			createdebugfile
			Set hpglfile5debug = fso.CreateTextFile(debugfile, True)
			createdebugfile_onerror
			
			debugfile=debugfilenoopos5
			createdebugfile
			Set hpglfiledebugnoopos5 = fso.CreateTextFile(debugfile, True)
			createdebugfile_onerror			
		End if
		
	End if
End If


'---------------------------------------------------------------
'Writefiles function
'---------------------------------------------------------------
Function writefiles(writevar)

		writefilessplit=Split(writevar,"#@#")
		Select Case writefilessplit(1)
			Case "1"
				Select Case write5
					Case True
						hpglfile5.Write writefilessplit(0)					
						If exportdebugfiles=True Then
								hpglfile5debug.Write writefilessplit(0)
								hpglfiledebugnoopos5.Write writefilessplit(0)
						End If
					Case Else
						If extentionval=".xml" Then
						
						
							Else
								hpglfile.Write writefilessplit(0)
						End if
						If exportdebugfiles=True Then
							If extentionval<>".xml" Then
								hpglfiledebug.Write writefilessplit(0)
							End if
							hpglfiledebug2.Write writefilessplit(0)
							If cutter="summa" then
								hpglfiledebugnoopos.Write writefilessplit(0)
							End If
							If cutter="konaal4" Then
								Select Case Left(writefilessplit(0),3)
									Case "IN;"
									Case "AL4"
									Case "AL3"
									Case "PR;"
									Case "PA;"
								Case else
								hpglfiledebugnoal4.Write writefilessplit(0)
								End select
							End if
						End if	
					
				End Select
				
				If postfilename="0" Then
					If Left(writefilessplit(0),3)="IN;" Or Left(writefilessplit(0),3)="PA;" Or Left(writefilessplit(0),2)="SP" Or Left(writefilessplit(0),3)="BP;" Or Left(writefilessplit(0),3)="PU;" Or Left(writefilessplit(0),3)="PG;" Then
						hpglfile5.Write writefilessplit(0)
						If exportdebugfiles=True Then
							hpglfile5debug.Write writefilessplit(0)
							hpglfiledebugnoopos5.Write writefilessplit(0)
						End if
					End if
				End If
				
			Case "2"		'opos marks
				hpglfile.Write writefilessplit(0)
				If exportdebugfiles=True Then
					If extentionval<>".xml" Then
						hpglfiledebug.Write writefilessplit(0)
					End if
					hpglfiledebug2.Write writefilessplit(0)
				End If
				
				If startopos=True And oposiswritten = False And postfilename="0" Then
				
					hpglfile5.Write writefilessplit(0)
					If exportdebugfiles=True Then
						hpglfile5debug.Write writefilessplit(0)
						
					End if
				End if
				
			Case "3"
				If exportdebugfiles=True Then
					hpglfiledebug2.Write writefilessplit(0)
				End If
			
			Case Else
				
		End Select
	
End function



'---------------------------------------------------------------
'Write header
'---------------------------------------------------------------

Select Case extentionval
	Case ".oxf"
		writefiles(";OPTISCOUT"&Chr(10)&"#@#1")
	Case ".dxf"	
		If dxfheader=True Then
		''	writethedxfheader
	
		End if
		writefiles("  0"&Chr(10)&"#@#1")
		writefiles("SECTION"&Chr(10)&"#@#1")
		writefiles("  2"&Chr(10)&"#@#1")
		writefiles("ENTITIES"&Chr(10)&"#@#1")
	Case ".cf2"
		writefiles("$BOF"&Chr(10)&"#@#1")
		writefiles("V2"&Chr(10)&"#@#1")
		writefiles("ORDER"&Chr(10)&"#@#1")
		writefiles("END"&Chr(10)&"#@#1")
		writefiles("MAIN,HUNARTON"&Chr(10)&"#@#1")
	
	writefiles("UR,1030,790"&Chr(10)&"#@#1")
writefiles("SCALE,1,1"&Chr(10)&"#@#1")
writefiles("C,test1,0,0,0,1.000,1.000"&Chr(10)&"#@#1")

writefiles("END"&Chr(10)&"#@#1")
writefiles("SUB,test1"&Chr(10)&"#@#1")

End Select

commentdata("1File Conversion done by EPS_Converter tool")
commentdata("1arguments: "&argulist)
commentdata("1"&unitsv&" units = 1mm")
commentdata("1Accuracy="&grainmm&"mm")
commentdata("1Convert points to units=*"&unitsv&"/"&mmtopoints)

'---------------------------------------------------------------
'Function to change the axis
'---------------------------------------------------------------
Function changeaxis(axtrans)
	'axisstring:
	'000->do nothing
	'100->x=y
	'010->x=mediawidh-x
	'011->x=mediawidh-x,y=mediaheight-y
	'001->y=mediaheight-y
	'111->x=mediaheight-y,y=mediawidth-x
	'110->x=mediaheight-y,y=x   Needed for Roland: changeaxis("110_x_y")
	'101->x=y,y=mediawidth-x
	splitaxtrans=Split(axtrans,"_")
	axtransorgx=splitaxtrans(1)
	transx=axtransorgx
	
	axtransorgy=splitaxtrans(2)
	transy=axtransorgy

	Select Case splitaxtrans(0)
		Case "110"
		transx=(mediasizey)-axtransorgy
		'MsgBox transx&"=("&mediasizey&")-"&axtransorgy
		transy=axtransorgx
	End Select 

End function


'---------------------------------------------------------------
'Function to rotate imageblock on the sheet
'---------------------------------------------------------------

Function rotatesheet
	commentdata("1rotatesheet_applyrotationtoall:"&applyrotationtoall)
	Select Case applyrotationtoall
		Case "0"
		
		Case "-1"
			xlocation2=ylocation
			ylocation2=xlocation
			xlocation=(mediasizex*convertpointstounits)-xlocation2
			ylocation=ylocation2
			
		Case "-2"
			xlocation=(mediasizex*convertpointstounits)-xlocation
			ylocation=(mediasizey*convertpointstounits)-ylocation
			
		Case "-3"

			xlocation2=ylocation
			ylocation2=xlocation
			xlocation=xlocation2
			commentdata("2mediasizey*convertpointstounits)-ylocation2:"&(mediasizey*convertpointstounits)&"-"&ylocation2)
			
			ylocation=(mediasizey*convertpointstounits)-ylocation2
			
	End Select
End Function

'---------------------------------------------------------------
'Function to read and write the sheet size
'---------------------------------------------------------------

Function checksheetsize
	
		'READ THE SHEET SIZE
		'WRITE THE SHEET SIZE WHEN FORMAT=OXF OR XML
	
		If Left(mytxtline,19)="%%BoundingBox: 0 0 " Then
			mediasizesplit=Split(mytxtline," ")
			mediasizex=mediasizesplit(3)
			
			mediasizey=mediasizesplit(4)
			
			commentdata("1Mediasizex="&mediasizex*convertpointstounits&" units")
			commentdata("1Mediasizey="&mediasizey*convertpointstounits&" units")
			If 	mediasizex<>"" And mediasizex<>"0" And mediasizey<>"" And mediasizey<>"0" Then
				Select Case extentionval
					Case ".oxf"
							writefiles("SR5,"&mediasizex*convertpointstounits&";"&Chr(10)&"#@#1")
							writefiles("SR6,"&mediasizey*convertpointstounits&";"&Chr(10)&"#@#1")
					Case ".xml"	
							dimnode.setAttribute "width",Round(mediasizex*convertpointstounits,figuresaftercomma)
							dimnode.setAttribute "height",Round(mediasizey*convertpointstounits,figuresaftercomma)
				End Select
			End if
		End If
		
End Function


'---------------------------------------------------------------
'Function to write opos marks
'---------------------------------------------------------------

Function writeoposmarks

	If startopos=True And oposiswritten = False Then			
								
		writefiles(Chr(27)&";@:"&Chr(10)&"#@#2")
		writefiles("SET SPECIAL_LOAD="&summaspecialload&"."&Chr(10)&"#@#2")	
		writefiles("SET MARKER_X_DIS="&Abs(Round(MARKER_X_DIS))&"."&Chr(10)	&"#@#2")	
		writefiles("SET MARKER_Y_DIS="&Abs(Round(MARKER_Y_DIS))&"."&Chr(10) &"#@#2")
		writefiles("SET MARKER_X_SIZE="&Abs(Round(MARKER_X_SIZE))&"."&Chr(10)&"#@#2")		
		writefiles("SET MARKER_Y_SIZE="&Abs(Round(MARKER_X_SIZE))&"."&Chr(10)&"#@#2")		
		writefiles("SET MARKER_X_N="&Abs(Round(MARKER_X_N))&"."&Chr(10)	&"#@#2")	
		writefiles("LOAD_MARKERS."&Chr(10)&"#@#2")			
		writefiles("END."&Chr(10)&"#@#2")					
		
			
		writefiles("IN;"&Chr(10)&"#@#1")							
		writefiles("BP;"&Chr(10)&"#@#1")									
		
		oposiswritten=True
		startopos=False											
	End If


End Function

'---------------------------------------------------------------
'Function to read opos marks
'---------------------------------------------------------------

Function readoposmarks

	Select case hcommand
		case"PU"	
			commentdata("1readoposmarks PU")
			startoposmark=True
			
			If pux="" Then
				commentdata("1pux:"&origxlocation)
				MARKER_X_N=1
				oposarrayx="_"&origxlocation&"_"
				smallestx=origxlocation
				largestx=origxlocation
				pux=origxlocation
				Else
					commentdata("1If "&origxlocation&"<"&smallestx &" Then")
					If origxlocation<smallestx Then
						smallestx=origxlocation
					End If
					
					If origxlocation>largestx Then
						largestx=origxlocation
					End if
				
				
					oposarrayxsplit=Split(oposarrayx,"_"&origxlocation&"_")
					If UBound(oposarrayxsplit)=0 Then
						MARKER_X_N=MARKER_X_N+1
						MARKER_X_DIS=origxlocation-pux
						
						commentdata("1SETMARKER_X_DIS="&MARKER_X_DIS)
						
						oposarrayx=oposarrayx&origxlocation&"_"
						pux=origxlocation
					End if
			End if		
				
				
			If puy="" Then
			commentdata("1puy:"&origylocation)
				smallesty=origylocation
				largesty=origylocation
				oposarrayy="_"&origylocation&"_"
				puy=origylocation
				Else
				If origylocation<smallesty Then
				smallesty=origylocation
				End if
				If origylocation>largesty Then
					largesty=origylocation
				End If
				oposarrayysplit=Split(oposarrayy,"_"&origylocation&"_")
				If UBound(oposarrayysplit)=0 Then
					MARKER_Y_DIS=origylocation-puy
					oposarrayy=oposarrayy&origylocation&"_"
					puy=origylocation
				End if
			End if		
									
		case"PD"
			commentdata("1readoposmarks PD")
			If pdx="" Then
				pdx=origxlocation
				Else
					If MARKER_X_SIZE=0 Then
						commentdata("2origxlocation="&origxlocation&" pdx="&pdx)
						If origxlocation<>pdx Then
						
							MARKER_X_SIZE=origxlocation-pdx
							If MARKER_X_SIZE < 0 Then
							MARKER_X_SIZE=MARKER_X_SIZE*-1
							End if
						End if
					End if
			End if	
			
	End Select
End Function


'---------------------------------------------------------------
'Function to write Pen up/pen down command
'---------------------------------------------------------------

Function writepupd
	On Error resume Next
	commentdata("2pickuprotation"&rotationval)
	commentdata("2applyrotationtoall:"&myarraysplit(0)&applyrotationtoall)
	commentdata("1before rotatesheet:"&myarraysplit(1)&"+"&Round(matrixx,5)&","&myarraysplit(2)&"+"&Round(matrixy,5))
	ptfromarrayx=myarraysplit(1)
	ptfromarrayy=myarraysplit(2)
					
	xlocation=ptfromarrayx+Round(matrixx,5)
	ylocation=ptfromarrayy+Round(matrixy,5)
	commentdata("2location"&xlocation&" "&ylocation)
	rotatesheet			'call function to rotate the image block on the sheet.
	
	origxlocation=Round(xlocation,1)
	origylocation=Round(ylocation,1)
	
	commentdata("1after rotatesheet:"&xlocation&","&ylocation)
	commentdata("2"&"startopos:"&startopos&" - "&myarraysplit(0))
	
	If startopos = True Then
		commentdata("1startopos = True")
		hcommand=myarraysplit(0)
		readoposmarks
		Else
		
		If write5=True Then
			'reversed cut file
			xlocation=largestx+MARKER_X_SIZE-xlocation
			ylocation=largesty-ylocation
			Else
				xlocation=xlocation-smallestx
				ylocation=ylocation-smallesty+MARKER_X_SIZE
		End if
		
		curaction=myarraysplit(0)
		
		If write5=True Then
			Select Case curaction
				Case "PU"
					curaction="PD"
					detectpu=1
				Case "PD"
					If detectpu=1 Then
					curaction="nt"
					detectpu=2
					End If
					If detectpu=2 Then
					curaction="PU"
						detectpu=0
					End if
			End select
		End if
		
		commentdata("2"&"rotationval:"&rotationval)
		commentdata("2"&"curaction:"&curaction)
		If curaction<>"nt" then
					Select Case extentionval
						Case ".xml"
							select case curaction
								case "PD"
								If Round(xlocation,figuresaftercomma)=previousx And Round(ylocation,figuresaftercomma)=previousy Then
								Else
						
								  	Set shapenode= xmlDoc.createNode(1,"shape","")   
							
                                    contnode.appendChild(shapenode)
                              
                                    shapenode.setAttribute "type","line"
                                   	shapenode.setAttribute "x1",previousx
                                   	shapenode.setAttribute "y1",previousy
								   	shapenode.setAttribute "x2",Round(xlocation,figuresaftercomma)
                                   	shapenode.setAttribute "y2",Round(ylocation,figuresaftercomma)
                                   												previousx=Round(xlocation,figuresaftercomma)
											previousy=Round(ylocation,figuresaftercomma)
                                   	End if
								case "PU"
									previousx=Round(xlocation,figuresaftercomma)
									previousy=Round(ylocation,figuresaftercomma)
									commentdata("2"&"PU:"&previousx& " "&previousy)
							End Select
							
						Case ".gbr"
						
							select case curaction
									case "PD"
									
										
										
										linepupd="X"&Round(xlocation,figuresaftercomma)& "Y"&Round(ylocation,figuresaftercomma)&"*"&Chr(10)
											previousx=Round(xlocation,figuresaftercomma)
												previousy=Round(ylocation,figuresaftercomma)
										
									case "PU"
								
	
										linepupd="N"&pucounter&"*"&Chr(10)
										linepupd=linepupd&"D2*"&Chr(10)
										linepupd=linepupd&"M15*"&Chr(10)
										linepupd=linepupd&"X"&Round(xlocation,figuresaftercomma)& "Y"&Round(ylocation,figuresaftercomma)&"*"&Chr(10)
										linepupd=linepupd&"M14*"&Chr(10)
											previousx=Round(xlocation,figuresaftercomma)
												previousy=Round(ylocation,figuresaftercomma)	
									pucounter=pucounter+1
									
							End Select
							Case ".cf2"
								select case curaction
										case "PD"
											If Round(xlocation,figuresaftercomma)=previousx And Round(ylocation,figuresaftercomma)=previousy Then
												else
													linepupd="L,2,2,0,"&previousx&","&previousx&","&linepupd&Round(xlocation,figuresaftercomma)&","&linepupd&Round(ylocation,figuresaftercomma)&",0,0.000"&Chr(10)
															previousx=Round(xlocation,figuresaftercomma)
													previousy=Round(ylocation,figuresaftercomma)
										
											End if
								case "PU"
											
											previousx=Round(xlocation,figuresaftercomma)
											previousy=Round(ylocation,figuresaftercomma)
											commentdata("2"&"PU:"&previousx& " "&previousy)
							end select
						Case ".dxf"	
							select case curaction
								case "PD"
									If Round(xlocation,figuresaftercomma)=previousx And Round(ylocation,figuresaftercomma)=previousy Then
										else
											linepupd="  0"&Chr(10)
											linepupd=linepupd&"LINE"&Chr(10)
											If cutter="multicam" then
												linepupd=linepupd&"100"&Chr(10)
												linepupd=linepupd&"AcDbEntity"&Chr(10)
											End if
											linepupd=linepupd&"  8"&Chr(10)
											linepupd=linepupd&layername&Chr(10)
											linepupd=linepupd&"100"&Chr(10)
											linepupd=linepupd&"AcDbLine"&Chr(10)
											linepupd=linepupd&" 10"&Chr(10)
											linepupd=linepupd&previousx&Chr(10)
											linepupd=linepupd&" 20"&Chr(10)
											linepupd=linepupd&previousy&Chr(10)
											linepupd=linepupd&" 30"&Chr(10)
											linepupd=linepupd&" 0"&Chr(10)
											linepupd=linepupd&" 11"&Chr(10)
											linepupd=linepupd&Round(xlocation,figuresaftercomma)&Chr(10)
											linepupd=linepupd&" 21"&Chr(10)
											linepupd=linepupd&Round(ylocation,figuresaftercomma)&Chr(10)
											linepupd=linepupd&" 31"&Chr(10)
											linepupd=linepupd&" 0"&Chr(10)
											previousx=Round(xlocation,figuresaftercomma)
											previousy=Round(ylocation,figuresaftercomma)
											commentdata("2"&"PD")
									End if
									
								case "PU"
									
									previousx=Round(xlocation,figuresaftercomma)
									previousy=Round(ylocation,figuresaftercomma)
									commentdata("2"&"PU:"&previousx& " "&previousy)
							end select
						Case Else
							
							If supportMK <> True Then
								linepupd=curaction&" "&Round(xlocation,figuresaftercomma)&","&Round(ylocation,figuresaftercomma)&";"&Chr(10)
								Else
								linepupd=curaction&" "&Round(xlocation,figuresaftercomma)&","&-Round((mediasizey*convertpointstounits)-ylocation,figuresaftercomma)&";"&Chr(10)
							End If
					End Select
					
					If layername=regmarksname And supportMK = True Then
							Else
								If regmarksatend=True And layername = regmarksname Then
									textatend=textatend&linepupd
									Else
										If cutter="konaal4" And layername=regmarksname Then
											If curaction="PD" Then
												If previousxkona = Round(xlocation,figuresaftercomma) Then
													'vertical line
													If konaal4x1="" Then
														konaal4x1=Round(xlocation,figuresaftercomma)
														Else
														
														If Round(xlocation,figuresaftercomma)>konaal4x1 then
															konaal4x2=Round(xlocation,figuresaftercomma)
															Else
																	If Round(xlocation,figuresaftercomma)<>konaal4x1 then
																			konaal4x2=konaal4x1
																			konaal4x1=Round(xlocation,figuresaftercomma)
																	End if
														End If
													End if
																																	
													Else
																If konaal4y1="" Then
																	konaal4y1=Round(ylocation,figuresaftercomma)
																
																	Else
																	
																	If Int(Round(ylocation,0))>Int(Round(konaal4y1,0)) then
																		konaal4y2=Round(ylocation,figuresaftercomma)
																		
																		Else
																				If Int(Round(ylocation,0))<>Int(Round(konaal4y1,0)) Then
																				
																				konaal4y2=konaal4y1
																				konaal4y1=Round(ylocation,figuresaftercomma)
																				End if
																	End If
																End if
																
												End if														
											End if
											previousxkona=Round(xlocation,figuresaftercomma)
											previousykona=Round(ylocation,figuresaftercomma)
											
											else
											
											writefiles(linepupd&"#@#1")
										
										End if
								End if
					End if
		End if
		
	End If
	
	If Err.Number>0 Then
		posterror("issue with array: "&myarray(counter)&": "&err.Description)
		Err.clear
	End If
	circlearr=False
End Function


'---------------------------------------------------------------
'Function to write circle command
'---------------------------------------------------------------


Function writecircle

	On Error resume Next
	
		commentdata("1--"&myarraysplit(1)&"+"&matrixx&","&myarraysplit(2)&"+"&matrixy)
		If myarraysplit(0)="AA" Then
			If circlearr=False Then
				If layername = regmarksname And supportMK=True Then
				else
				If regmarksatend=True And layername = regmarksname Then
					If previousoperation<>3 then
						textatend=textatend&"PD;"&Chr(10)
					End if
					
					Else
							If previousoperation<>3 And extentionval <> ".dxf" Then
								writefiles("PD;"&Chr(10)&"#@#1")
							End if
				End if
				End if
			End If
			circlearr=true
		End If

	xlocation=myarraysplit(1)+matrixx
	ylocation=myarraysplit(2)+matrixy
	commentdata("2ylocation2:"&ylocation)
	commentdata("2xlocation2:"&xlocation)
	
	rotatesheet
	
	xlocation=xlocation-smallestx
	ylocation=ylocation-smallesty+MARKER_X_SIZE

	commentdata("2ylocation3:"&ylocation)
	commentdata("2previonsylocation:"&previousy)
	
	commentdata("2xlocation3:"&xlocation)
	commentdata("2previonsxlocation:"&previousx)
	
	If Round((xlocation-previousx),1) = 0 Then
		circsize=Round((ylocation-previousy),1)
		Else
		circsize=Round((xlocation-previousx),1)
	End if

	If circsize < 0 Then
			circsize=circsize*-1
	End If
										
	Select Case extentionval
		Case ".dxf"	
				Select Case applyrotationtoall
					Case "0"
						lineci="  0"&Chr(10)
						lineci=lineci&"CIRCLE"&Chr(10)
						If cutter="multicam" then
							lineci=lineci&"100"&Chr(10)
							lineci=lineci&"AcDbEntity"&Chr(10)
						End if
						lineci=lineci&"  8"&Chr(10)
						lineci=lineci&layername&Chr(10)
						lineci=lineci&" 100"&Chr(10)
						lineci=lineci&"AcDbCircle"&Chr(10)
						lineci=lineci&" 10"&Chr(10)
						lineci=lineci&Round(xlocation,figuresaftercomma)&Chr(10)
						lineci=lineci&" 20"&Chr(10)
						lineci=lineci&Round(ylocation,figuresaftercomma)&Chr(10)
						lineci=lineci&" 30"&Chr(10)
						lineci=lineci&" 0"&Chr(10)
						lineci=lineci&" 40"&Chr(10)
						lineci=lineci&circsize&Chr(10)
						commentdata("2xresult:"&xlocation&"-"&previousx&"="&Round((xlocation-previousx),1))
						
					Case Else
						lineci="  0"&Chr(10)
						lineci=lineci&"CIRCLE"&Chr(10)
						If cutter="multicam" then
							lineci=lineci&"100"&Chr(10)
							lineci=lineci&"AcDbEntity"&Chr(10)
						End if
						lineci=lineci&"  8"&Chr(10)
						lineci=lineci&layername&Chr(10)
						lineci=lineci&" 10"&Chr(10)
						lineci=lineci&Round(xlocation,figuresaftercomma)&Chr(10)
						lineci=lineci&" 20"&Chr(10)
						lineci=lineci&Round(ylocation,figuresaftercomma)&Chr(10)
						lineci=lineci&" 40"&Chr(10)
						lineci=lineci&circsize&Chr(10)
						commentdata("2result:"&xlocation&"--"&ylocation&"--"&lastpnty&"--"&lastpnty&"="&Round((ylocation-previousy),1))
						
				End select
				
		Case Else	
		
			If supportMK<>True Or layername<>regmarksname Then
				If supportMK<>True Then
					If cutter="konaal4" Then
						xlocation=mediasizex*convertpointstounits-xlocation
						cirorient=CInt(myarraysplit(3))*-1
							lineci=myarraysplit(0)&" "&Round(xlocation,figuresaftercomma)&","&Round(ylocation,figuresaftercomma)&","&cirorient&";"&Chr(10)
						Else
							lineci=myarraysplit(0)&" "&Round(xlocation,figuresaftercomma)&","&Round(ylocation,figuresaftercomma)&","&myarraysplit(3)&";"&Chr(10)
					End if			
					Else
						lineci=myarraysplit(0)&" "&Round(xlocation,figuresaftercomma)&","&-Round((mediasizey*convertpointstounits)-ylocation,figuresaftercomma)&","&myarraysplit(3)&";"&Chr(10)
				End if
			
				Else
				
					MKstring=Round(xlocation,figuresaftercomma)&","&-Round((mediasizey*convertpointstounits)-ylocation,figuresaftercomma)&";"&Chr(10)
				
					lineci="MK"&MKcounter&","&MKstring
			
					If lastsupportMK=MKstring Then
					lineci=""
							else
								lastsupportMK=MKstring
								MKcounter=MKcounter+1
				End If
				
			End if
	End select
	
	
	
	If extentionval = ".dxf" And previouscircle=lineci Then
		Else
			
			If lineci<>"" then
				If regmarksatend=True And layername = regmarksname Then
					textatend=textatend&lineci
					else
						writefiles(lineci&"#@#1")
				End If
			End if
	End if
	
	previouscircle=lineci
	
End Function


'---------------------------------------------------------------
'Function to write bezier command
'---------------------------------------------------------------

Function writebezier

	xlocation=myarraysplit(1)+matrixx
	ylocation=myarraysplit(2)+matrixy
	
	rotatesheet
	
	xlocation=xlocation-smallestx
	ylocation=ylocation-smallesty+MARKER_X_SIZE
	
	bzx1=xlocation
	bzy1=ylocation
	
	xlocation=myarraysplit(3)+matrixx
	ylocation=myarraysplit(4)+matrixy
	rotatesheet
	bzx2=xlocation-smallestx
	bzy2=ylocation-smallesty+MARKER_X_SIZE	
	
	xlocation=myarraysplit(5)+matrixx
	ylocation=myarraysplit(6)+matrixy
	rotatesheet
	bzx3=xlocation-smallestx
	bzy3=ylocation-smallesty+MARKER_X_SIZE

	Select Case extentionval
			Case ".xml"
			
				If layername <> regmarksname then
									
			
				  	Set shapenode= xmlDoc.createNode(1,"shape","")   
	                contnode.appendChild(shapenode)
	                shapenode.setAttribute "type","curve"
	                shapenode.setAttribute "x1",previousx
	               	shapenode.setAttribute "y1",previousy
	               	shapenode.setAttribute "x2",Round(bzx3,figuresaftercomma)
					shapenode.setAttribute "y2",Round(bzy3,figuresaftercomma)
	               	
	               	shapenode.setAttribute "cx1",Round(bzx1,figuresaftercomma)
	               	shapenode.setAttribute "cy1",Round(bzy1,figuresaftercomma)
	               	shapenode.setAttribute "cx2",Round(bzx2,figuresaftercomma)
	               	shapenode.setAttribute "cy2",Round(bzy2,figuresaftercomma)
	               	
					previousx=Round(bzx3,figuresaftercomma)
					previousy=Round(bzy3,figuresaftercomma)
					
					Else

             					If xmlmarkx="" Then
		                				xmlmarkx=previousx
		                				Else
		                					If previousx < xmlmarkx Then
		                						xmlmarkx=previousx
		                					End if
		                			End If
		                		If xmlmarky="" Then
		                				xmlmarky=previousy
		                				Else
		                					If previousy < xmlmarky Then
		                						xmlmarky=previousy
		                					End if
		                		End If	
		                			
		                		If xmlmarkxmax="" Then
		                				xmlmarkxmax=previousx
		                				Else
		                					If previousx > xmlmarkxmax Then
		                						xmlmarkxmax=previousx
		                					End if
		                		End If
             				
             					If xmlcirclecounter=3 Then
             						sizeofmark=xmlmarkxmax-xmlmarkx
	             					marksnode.setAttribute "size",Round(sizeofmark,figuresaftercomma)
							 		Set positionnode= xmlDoc.createNode(1,"position","")   
		                			marksnode.appendChild(positionnode)
		                    		positionnode.setAttribute "x",Round(xmlmarkx+(sizeofmark/2),figuresaftercomma)
									positionnode.setAttribute "y",Round(xmlmarky+(sizeofmark/2),figuresaftercomma)
		               				xmlcirclecounter=0
		               				xmlcirclecountertotal=xmlcirclecountertotal+1
		               				marksnode.setAttribute "count",xmlcirclecountertotal
		               				marksnode.setAttribute "type","dot"
		               				
		               				xmlmarkx=""
		               				xmlmarky=""
		               				xmlmarkxmax=""
		               				Else
		               					xmlcirclecounter=xmlcirclecounter+1 
		                		End if
		                	
								previousx=Round(bzx3,figuresaftercomma)
								previousy=Round(bzy3,figuresaftercomma)
					End If
					
			Case ".dxf"	
				linebz="  0"&Chr(10)
				linebz=linebz&"SPLINE"&Chr(10)
				If cutter="multicam" Then
					linebz=linebz&"100"&Chr(10)
					linebz=linebz&"AcDbEntity"&Chr(10)
				End if
				linebz=linebz&"8"&Chr(10)
				linebz=linebz&layername&Chr(10)
				If cutter="multicam" Then
					linebz=linebz&"370"&Chr(10)
					linebz=linebz&"-1"&Chr(10)
				End if
				linebz=linebz&"100"&Chr(10)
				linebz=linebz&"AcDbSpline"&Chr(10)
				linebz=linebz&"210"&Chr(10)
				linebz=linebz&"0.0"&Chr(10)
				linebz=linebz&"220"&Chr(10)
				linebz=linebz&"0.0"&Chr(10)
				linebz=linebz&"230"&Chr(10)
				linebz=linebz&"1.0"&Chr(10)
				linebz=linebz&"70"&Chr(10)
				linebz=linebz&"8"&Chr(10)
				linebz=linebz&"71"&Chr(10)
				linebz=linebz&"3"&Chr(10)
				linebz=linebz&"72"&Chr(10)
				linebz=linebz&"8"&Chr(10)
				linebz=linebz&"73"&Chr(10)
				linebz=linebz&"4"&Chr(10)
				
				If cutter="multicam" Then
				linebz=linebz&"74"&Chr(10)
				linebz=linebz&"0"&Chr(10)				
								linebz=linebz&"42"&Chr(10)
				linebz=linebz&"1e-07"&Chr(10)
								linebz=linebz&"43"&Chr(10)
				linebz=linebz&"1e-07"&Chr(10)
				End if
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"0.0"&Chr(10)				
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"0.0"&Chr(10)				
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"0.0"&Chr(10)				
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"0.0"&Chr(10)	
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"1.0"&Chr(10)				
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"1.0"&Chr(10)				
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"1.0"&Chr(10)				
				linebz=linebz&"40"&Chr(10)			
				linebz=linebz&"1.0"&Chr(10)	
				linebz=linebz&"10"&Chr(10)
				linebz=linebz&previousx&Chr(10)
				linebz=linebz&"20"&Chr(10)
				linebz=linebz&previousy&Chr(10)			
				linebz=linebz&"30"&Chr(10)  
				linebz=linebz&"0.0"&Chr(10)
				linebz=linebz&"10"&Chr(10)
				linebz=linebz&Round(bzx1,figuresaftercomma)&Chr(10)
				linebz=linebz&"20"&Chr(10)
				linebz=linebz&Round(bzy1,figuresaftercomma)&Chr(10)			
				linebz=linebz&"30"&Chr(10)  
				linebz=linebz&"0.0"&Chr(10)
				linebz=linebz&"10"&Chr(10)
				linebz=linebz&Round(bzx2,figuresaftercomma)&Chr(10)
				linebz=linebz&"20"&Chr(10)
				linebz=linebz&Round(bzy2,figuresaftercomma)&Chr(10)			
				linebz=linebz&"30"&Chr(10)  
				linebz=linebz&"0.0"&Chr(10)
				linebz=linebz&"10"&Chr(10)
				linebz=linebz&Round(bzx3,figuresaftercomma)&Chr(10)
				linebz=linebz&"20"&Chr(10)
				linebz=linebz&Round(bzy3,figuresaftercomma)&Chr(10)			
				linebz=linebz&"30"&Chr(10)  
				linebz=linebz&"0.0"&Chr(10)
			
				previousx=Round(bzx3,figuresaftercomma)
				previousy=Round(bzy3,figuresaftercomma)
			
			Case else
	
				linebz=myarraysplit(0)&" "&Round(bzx1,figuresaftercomma)&","&Round(bzy1,figuresaftercomma)&","&Round(bzx2,figuresaftercomma)&","&Round(bzy2,figuresaftercomma)&","&Round(bzx3,figuresaftercomma)&","&Round(bzy3,figuresaftercomma)&";"&Chr(10)
	End select
	If regmarksatend=True And layername = regmarksname Then
			textatend=textatend&linebz
			Else
				writefiles(linebz&"#@#1")
	End if
	circlearr=False
End function

'---------------------------------------------------------------
'Function to write layername
'---------------------------------------------------------------

Function writelayername

	'add layername to array first
	inarray=0
	For y = 0 To UBound(layerlist)
	

		    
		  	If layername=layerlist(y) Then
                Inarray=1
                    
          end if        
     Next
	''MsgBox "Inarray"&Inarray
	If inarray=0 Then
		ReDim Preserve layerlist(UBound(layerlist) + 1)
		layerlist(UBound(layerlist)) = layername
		''MsgBox layername
	End if
''MsgBox UBound(layerlist)
	If IsNumeric(layername)=true Then
		If regmarksatend=True And layername = regmarksname Then
			textatend=textatend& "SP"&layername&";"&Chr(10)&"PA;"&Chr(10)
				Else
				
					If extentionval=".dxf" Then
						'write nothing yet.
							Else
								If cutter="konaal4" And layername<>regmarksname And konaal4x1<>"" Then
							
									writefiles("IN;PROGSTEP10;"&Chr(10)&"#@#1")
									writefiles(cutteroption&","&konaal4x1&","&konaal4y1&","&konaal4x2&","&konaal4y2&";"&Chr(10)&"#@#1")
									konaal4x1=""
								End if
								commentdata("1Start the layer")
								If layername<>"" Then
								
									If cutter="konaal4" And layername=regmarksname Then
								
										else
										
										
										Select Case cutter
											Case "cf2"
											Case "roland"
													'writefiles("IN;"&Chr(10)&"#@#1")
													writefiles("!ST1;"&Chr(10)&"#@#1")
													writefiles("VS;"&Chr(10)&"#@#1")
 													writefiles("PA;"&Chr(10)&"#@#1")
											Case "Kuris"
										
													writefiles("H1*"&Chr(10)&"#@#1")
													writefiles("G71*"&Chr(10)&"#@#1")
													writefiles("M20*"&Chr(10)&"#@#1")
													writefiles("Just table*"&Chr(10)&"#@#1")
													writefiles("N1*"&Chr(10)&"#@#1")
													writefiles("D2*"&Chr(10)&"#@#1")
											
											
											Case "Jwei"
										
												If layername <> regmarksname then
												 	Set contnode= xmlDoc.createNode(1,"contour","")   
		            								pathsnode.appendChild(contnode)
		            								contnode.setAttribute "name",layername
		            								contnode.setAttribute "tool",layername
												End if
											Case Else
												writefiles("SP"&layername&";"&Chr(10)&"#@#1")		'write the text file layername
										End select
										
										
										
										
											If cutter="konaal4" Then
											else
										writefiles("PA;"&Chr(10)&"#@#1")
										End if
									End if
								End if
					End if
		End If
			
			
			Else
				If layername="OPOS" And cutter="summa" Then
					startopos=True
					commentdata("2StartOPOS")
					
					Else
						writeoposmarks
						'Write the layername
						
						If cutter="summa" Then
							commentdata("1"&layername)
							layernamesplit=Split(layername,"\")
							If UBound(layernamesplit)>0 Then
								If IsNumeric(layernamesplit(1)) Then
									If regmarksatend=True And layername = regmarksname Then
										If extentionval<>".dxf" Then
										If layernamesplit(1)<>"" then
										textatend=textatend&"SP"&layernamesplit(1)&";"&Chr(10)&"PA;"&Chr(10)
										End if
										end if
										else
											If extentionval<>".dxf" And cutter<>"konaal4" Then
											writefiles("SP"&layernamesplit(1)&";"&Chr(10)&"#@#1")
											writefiles("PA;"&Chr(10)&"#@#1")
											end if
									End if
								End if
								
							End If
							
							else
										If extentionval<>".dxf" Then
											If regmarksatend=True And layername = regmarksname Then
												
												textatend=textatend&"PU;"&layerselection&layername&";"&Chr(10)&"PA;"&Chr(10)
											


											Else
											
												If cutter="konaal4" And layername<>regmarksname And konaal4x1<>"" Then
												
												
													writefiles("IN;PROGSTEP10;"&Chr(10)&"#@#1")
													writefiles(cutteroption&","&konaal4x1&","&konaal4y1&","&konaal4x2&","&konaal4y2&";"&Chr(10)&"#@#1")
													writefiles("PA;"&Chr(10)&"#@#1")
												
												
												
													konaal4x1=""
												End if
											
											
													commentdata("1Start the layer")
											
											
											Select Case cutter
												Case "cf2"
												Case "konaal4"
														writefiles(layername&";"&Chr(10)&"#@#1")
												Case "Kuris"
													''MsgBox "start layer"
													writefiles("H1*"&Chr(10)&"#@#1")
													writefiles("G71*"&Chr(10)&"#@#1")
													writefiles("M20*"&Chr(10)&"#@#1")
													writefiles("Just table*"&Chr(10)&"#@#1")
												
												
												
												Case "Jwei"
									
													If layername <> regmarksname then
													 	Set contnode= xmlDoc.createNode(1,"contour","")   
			            								pathsnode.appendChild(contnode)
			            								contnode.setAttribute "name",layername
			            								contnode.setAttribute "tool",layername
													End If
													
													
												Case "roland"
													'writefiles("IN;"&Chr(10)&"#@#1")
													
													If cutteroffset="" then			'urrently only used For Roland'
															addcutoffset=";"						'!ST1,m;
														Else							'specify offset (unit: micron ) must be INTEGER (0 to 1000)
															addcutoffset=","&cutteroffset&";"
															
													End If					
													
													
													writefiles("!ST1"&addcutoffset&Chr(10)&"#@#1")
													If toolforce<>"" then
														writefiles("!FS"&toolforce&";"&Chr(10)&"#@#1")	'n: tool force (unit: gf) INTEGER (20 to 600)
													End If
													If toolspeed<>"" then
														writefiles("VS"&toolspeed&";"&Chr(10)&"#@#1")	'n:tool Speed (unit: cm/sec) must be REAL (1 to 105)
													End if
													
 													writefiles("PA;"&Chr(10)&"#@#1")
 
												Case else
													writefiles("PU;"&layerselection&layername&";"&Chr(10)&"#@#1")
													writefiles("PA;"&Chr(10)&"#@#1")
													
													
													
													
													
											End select
												
											End if
										end if
						End if
				
				End if

		''previouswrittenlayer=layername
	End If
				
				
End Function




'---------------------------------------------------------------
'Read incoming eps file
'---------------------------------------------------------------
If (fso.FileExists(epsfilelocation)) Then
	Set MyFilea = fso.GetFile(epsfilelocation)
	Set MyStream = MyFilea.OpenAsTextStream(ForReading)
	

	
	
	
	
	
	
		
	Do While mytxtline<>"%%EOF"

			mytxtline=Mystream.ReadLine
		
		If mytxtline="W" And lastaction="rectangular" Then	' this is needed if a W command is detected.
			myarray(myarraycounter-1)=""					' a W command means that the last square was
			myarray(myarraycounter-2)=""					' a clipping rectangle.
			myarray(myarraycounter-3)=""
			myarray(myarraycounter-4)=""
			myarray(myarraycounter-5)=""
			
			'change 0 point and assignrotation to placed image
			
		End if

		
		If mytxtline=PageSetupdef And PageSetupdef<>"" And BeginPageSetup<>"1" And BeginPageSetupval<>"" Then
			mytxtline=BeginPageSetupval
			commentdata("1RESET LINE TO BeginPageSetupval:"&BeginPageSetupval)
			detectendpagesetup=false
		End if


		checksheetsize
		
		'------------------------------------------------------
		'WHEN A SHOWPAGE IS TRIGGERED, WRITE ARRAY TO TEXT FILE
		'------------------------------------------------------
		If mytxtline="q" Or mytxtline="q " Or mytxtline="Q n" Or Left(mytxtline,8)="showpage" Or mytxtline="s " Or mytxtline="n" Or mytxtline = "%%EOF" Then
			remembertextlinetest
			commentdata("1SHOWPAGE")
						
			If myarraycounter>0 Then
				commentdata("2Fndrotationval: "&rotationval)
				If layername<>"EMPTYLAYER" Then
				
					If layername=regmarksname And supportMK=True Then
					Else
					writelayername
					End if
				End if
		
					
					
					counter=0
					commentdata("2Matrixx="&matrixx)
					commentdata("2Matrixy="&matrixy)
					If matrixx="" Then
						matrixx=0
					End If
					If matrixy="" Then
						matrixy=0
					End If
					commentdata("2Orientation for"&layername&"="&rotationval)
					
					
	
					invertcounter=myarraycounter-1
					
					
					
					detectpu=1
					Do While counter< myarraycounter
					
					
						write5=false
					
						'regular order
						commentdata("2myarray:"&myarray(counter))	
						myarraysplit=Split(myarray(counter)," ")
						
						commentdata("2"&UBound(myarraysplit))
						If layername<>"EMPTYLAYER" then
							Select Case UBound(myarraysplit)
								Case 2	' WRITE PU/PD
										'------------		
									writepupd
									commentdata("7:"&myarray(counter))	
									previousoperation=2	
									
								Case 3	' WRITE CIRCLE
										' ------------
									
									commentdata("1Writecircle")
									writecircle
									previousoperation=3
								
								
								Case 6	'WRITE BEZIER
										'------------
									commentdata("5BZ:"&myarray(counter))
									writebezier
									previousoperation=6
					
							End select
						End if
					
					
						'inverse order
						
						If postfilename="0" Then
								write5=True
								
								myarraysplit=Split(myarray(invertcounter)," ")
								commentdata("2"&UBound(myarraysplit))
								
								Select Case UBound(myarraysplit)
									Case 2	' WRITE PU/PD
											'------------	
										writepupd		
										
									Case 3	' WRITE CIRCLE
											' ------------
										writecircle
									
									Case 6	'WRITE BEZIER
											'------------
										commentdata("5BZ:"&myarray(counter))
										writebezier
						
								End select	
								write5=false
						End if
					
					
						invertcounter=invertcounter-1
						counter=counter+1
					Loop
		
			
				If layername<>"EMPTYLAYER" Then
				
					commentdata("1SETMATRIX: "&Remembermatrixxconsumed&" "&Remembermatrixyconsumed)
					matrixx=Remembermatrixxconsumed
					matrixy=Remembermatrixyconsumed
					''memorizeorientation=""	'not used
				End if
				''	rectclip=""	'not used
					
					dashoff=0
					dashon=0
					Erase myarray
					myarraycounter=0
				
				Else
					
					If applyrotationtoallset<>True then
						commentdata("2SETapplyrotationtoall: "&rotationval)
						applyrotationtoall=rotationval
						applyrotationtoallset=True
						rotationval=0
					End if
			End If
		End If
		
		If Left(mytxtline,16)="%%BeginPageSetup" Then
			BeginPageSetup="1"
			PageSetupdef=""
			commentdata("1%%BeginPageSetup")	
		End if
		
		'------------------------------------------------------
		'When A cm command is triggered, 
		'set transformation matrixes
		'------------------------------------------------------

		If Right(mytxtline,8)="rectclip" Then
			commentdata("1RECTCLIPSETMATRIXX")
			matrixx=Remembermatrixx
			matrixy=Remembermatrixy
			''rectclip=Replace(mytxtline," rectclip","")
			commentdata("1Set markrotation="&markrotation)
		End if

		If Right(mytxtline,5)="] 0 d" Then 		'this is the instruction to start a dash pattern
												'e.g.[ 8.503900 566.929100 ] 0 d       on8.503900, off566.929100
			
			dashslplit=Split(mytxtline," ")
			If dashslplit(1)<>" " And dashslplit(1)<>"]" And dashslplit(1)<>" ]" And dashslplit(1)<>"] " then
			dashon=dashslplit(1)
			dashoff=dashslplit(2)
		
			commentdata("1DASHON"&dashon)
			End if
		End if

		If Right(mytxtline,14)="%%EndPageSetup" Then
			detectendpagesetup=true
		End if
		If Right(mytxtline,7)="EGS_Gs1" Then
			detectendpagesetup=false
		End if

		If Right(mytxtline,4)="] cm" Then
		
			commentdata("1defaultmatrix="&defaultmatrix)
			If defaultmatrix=false then
						commentdata("1"&mytxtline)
						currentmatrixline=0
					
						currentmatrixsplit=Split(mytxtline,"[ 1 0 0 1 ")
						If UBound(currentmatrixsplit)>0 Then
							If detectendpagesetup=True Then
								commentdata("1changeRotationval:"&rotationval &" ->"&" 0")
								rotationval="0"
								Else
								commentdata("1changemarkrotationval:"&markrotation &" ->"&" 0")
								markrotation ="0"
							End if
							currentmatrixline=1
							Else
						
							'If detectendpagesetup=True then
								currentmatrixsplit=Split(mytxtline,"[ 0 1 -1 0 ")	'0 1 -1 0=90 degrees
								If UBound(currentmatrixsplit)>0 Then
									
									If detectendpagesetup=True Then
										commentdata("1changeRotationval:"&rotationval &" ->"&" -1")
										rotationval="-1"
										Else
										commentdata("1changemarkrotationval:"&markrotation &" ->"&" -1")
										markrotation ="-1"
									End if
									currentmatrixline=1
									Else
									
								
										currentmatrixsplit=Split(mytxtline,"[ 0 -1 1 0 ")
										
										If UBound(currentmatrixsplit)>0 Then   '270 degrees
											If detectendpagesetup=True Then
												commentdata("1changeRotationval:"&rotationval &" ->"&" -3")
												rotationval="-3"
													Else
													commentdata("1changemarkrotationval:"&markrotation &" ->"&" -3")
													markrotation ="-3"
											End if
									
											currentmatrixline=1
											Else
											
												currentmatrixsplit=Split(mytxtline,"[ -1 0 0 -1 ") '180 degrees
												If UBound(currentmatrixsplit)>0 Then
													If detectendpagesetup=True Then
														commentdata("1changeRotationval:"&rotationval &" ->"&" -2")
														rotationval="-2"
														Else
														commentdata("1changemarkrotationval:"&markrotation &" ->"&" -2")
														markrotation ="-2"
													End if
													currentmatrixline=1
												
												End if
										End if
										
										
								End If
						
						End If
						If detectendpagesetup=False then
						
							currentmatrix=Replace(currentmatrixsplit(1)," ] cm","")
							currentmatrixsplit=Split(currentmatrix," ")
							
								commentdata("1Detect transformation: "&matrixx&" "&matrixy & "with rotation "&rotationval)
								
								Select case markrotation 
									case "-3"
										matrixx=Remembermatrixxconsumed+(currentmatrixsplit(1))*convertpointstounits
										matrixy=Remembermatrixyconsumed-(currentmatrixsplit(0))*convertpointstounits
									Case "-2"
										matrixx=Remembermatrixxconsumed-(currentmatrixsplit(0))*convertpointstounits
										matrixy=Remembermatrixyconsumed-(currentmatrixsplit(1))*convertpointstounits
									Case "-1"
										matrixx=Remembermatrixxconsumed-(currentmatrixsplit(1))*convertpointstounits
										matrixy=Remembermatrixyconsumed+(currentmatrixsplit(0))*convertpointstounits
									Case else
										matrixx=Remembermatrixxconsumed+(currentmatrixsplit(0))*convertpointstounits
										matrixy=Remembermatrixyconsumed+(currentmatrixsplit(1))*convertpointstounits
								End select
									Remembermatrixx=(currentmatrixsplit(0))*convertpointstounits	'remembermatrix=matrix used for cliprect
									Remembermatrixy=(currentmatrixsplit(1))*convertpointstounits
									commentdata("2remembermatrix")
							
						End if
			
			Else
				currentmatrixsplit=Split(mytxtline," ")
				commentdata("1Detect special transformation: "&matrixx&"+"&currentmatrixsplit(5)&"*"&convertpointstounits)
				Select case markrotation
					Case "-3"
						matrixx=matrixx+(currentmatrixsplit(6)*convertpointstounits)
						matrixy=matrixy-(currentmatrixsplit(5)*convertpointstounits)
						
					Case "-2"
					matrixx=matrixx-(currentmatrixsplit(5)*convertpointstounits)
					matrixy=matrixy-(currentmatrixsplit(6)*convertpointstounits)	
						
						Case "-1"
					matrixx=matrixx-(currentmatrixsplit(6)*convertpointstounits)
					matrixy=matrixy+(currentmatrixsplit(5)*convertpointstounits)	
						
					Case else
					matrixx=matrixx+(currentmatrixsplit(5)*convertpointstounits)
					matrixy=matrixy+(currentmatrixsplit(6)*convertpointstounits)
						
				End select
		End if
		End If
		If Left(mytxtline,40)="/_defaultmatrix matrix currentmatrix def" Then
			commentdata("1SETdefaultmatrix=true")
			defaultmatrix=true
			Else
		
			defaultmatrix=false
		End if
		'------------------------------------------------------
		'When A setcolorspace command is triggered, 
		'set the layer name
		'------------------------------------------------------	
											
		If Right(mytxtline,13)="setcolorspace" Then
			commentdata("2"&mytxtline)
			layername="UNKNOWN"
			
			commentdata("1"&mytxtline)
			If Left(mytxtline,10)="CS_Default" then
					mytxtline=Mystream.ReadLine
				
					commentdata("2Direct Detection "&mytxtline&" layer")
					layername=Replace(mytxtline,"[/Separation ","")
					layernamesplit=Split(layername," /")
					layername=layernamesplit(0)
					layername=Replace(layername," setcolor ","")
					commentdata("1LAYERNAME:"&layername&"!")
					If layername="(Black)" Or layername="All" Or layername=" All" Or layername="0 0 0 0" Then
						commentdata("1LAYERNAME FOUND: "&layername)
						layername=regmarksname
					End If
					commentdata("2Direct Detection Layername: "&layername)
					Else
						colorresource=Replace(mytxtline,"CS_","")
						colorresource=Replace(colorresource," setcolorspace","")
						commentdata("1Find the "&colorresource&" colorresource")
						commentdata("1Find from "&mytxtline&" in colorresourcecontainer"&resourcecontainer)
						commentdata("2Split("&resourcecontainer&",@@"&colorresource&"@@)")
						resourcecontainersplit=Split(resourcecontainer,"@@"&colorresource&"@@")
						commentdata("2"&UBound(resourcecontainersplit))
						If UBound(resourcecontainersplit)>0 Then
						commentdata("2resourcecontainersplit(1):"&resourcecontainersplit(1))
							fndresourcesplit=Split(resourcecontainersplit(1),"@@")
							If UBound(fndresourcesplit)>0 Then
								layername=fndresourcesplit(0)
								commentdata("1Found layername:"&layername)
							End if
						End if
			End If
			layername=LTrim(layername)
			layername=Replace(layername,"/","")
			layername=Replace(layername,"(","")
			layername=Replace(layername,")","")	
			commentdata("7layername:"&layername)
			If layername="(Black)" Or layername="All" Or layername=" All" Or layername="0 0 0 0" Then
						layername=regmarksname
			End If
			commentdata("1LAYER:"&layername)
				markrotation=0
		End If
					
							
		'------------------------------------------------
		'WRITE Layer RESOURCE
		'------------------------------------------------
		If Left(mytxtline,10)="0 setcolor" Or Left(mytxtline,16)="0 0 0 0 setcolor" Then
			'layername="EMPTYLAYER"
			commentdata("2SET EMPTYLAYER")
		End If
	
		 
		If Right(mytxtline,8)="exch def" Then
			commentdata("1"&mytxtline)
			'/PS_CS4 /ColorSpace findresource  /CS_Cs1 exch def
			cospacesplit=Split(Replace(mytxtline," exch def","")," /ColorSpace findresource")
			
			resourcename=Replace(cospacesplit(0),"/PS_","")
			resourcevalue=LTrim(Replace(cospacesplit(1),"/CS_",""))
			newresourcename=resourcevalue
			
			If BeginPageSetup = "1" Then
				commentdata("1%%BeginPageSetup=1")
				defSplit=Split(mytxtline,"/ColorSpace findresource")
				If UBound(defSplit)>0 Then
					BeginPageSetupval = mytxtline
					
					commentdata("1%%BeginPageSetup= "&mytxtline)
					else
					
					
					PageSetupdef=Replace(mytxtline," exch def","")
					commentdata("1"&PageSetupdef)
					PageSetupdefsplit=Split(PageSetupdef,"/")
					PageSetupdef=""&PageSetupdefsplit(1)
					commentdata("1SETPageSetupdef:"&PageSetupdef)
					BeginPageSetup = "2"
				End if
			End If
			
			
			commentdata("1exch def test: "&mytxtline)
			commentdata("1TESTRESOURCECONTAINER"&resourcecontainer&"VS"&"@@"&resourcename&"@@")
			resourcecontainersplit=Split(resourcecontainer,"@@"&resourcename&"@@")
			commentdata("7"&UBound(resourcecontainersplit))
			If UBound(resourcecontainersplit)>0 Then
							fndresourcesplit=Split(resourcecontainersplit(1),"@@")
							commentdata("4"&UBound(fndresourcesplit))
							If UBound(fndresourcesplit)>0 Then
								resourcevalue=fndresourcesplit(0)
								commentdata("2Found resourcevalue:"&resourcevalue)
								
								commentdata("2newresourcename:"&newresourcename)
								resourcecontainersplit=Split(resourcecontainer,"@@"&newresourcename&"@@")
								If UBound(resourcecontainersplit)>0 Then
								
								resourcecontainersplitb=Split(resourcecontainersplit(1),"@@")
								If resourcevalue<>"" Then
									restsplit=Split(resourcecontainersplit(1),"@@")
									restcounter=1
									resttext=""
								Do While restcounter<UBound(restsplit)+1
									If resttext<>"" Then
										resttext=resttext&"@@"
									End if
									resttext=resttext&restsplit(restcounter)
									restcounter=restcounter+1
								loop
								
								commentdata("2rest:"&resttext)
								resourcevaluesplita=Split(resourcevalue," /PS_")
								If UBound(resourcevaluesplita)>0 Then
										resourcevalue=resourcevaluesplita(0)
								End If
								
								resourcecontainer=resourcecontainersplit(0)&"@@"&Replace(newresourcename,"@@","")&"@@"&Replace(resourcevalue,"@@","")&"@@"&resttext&"@@"
								commentdata("1nwresourcecontainer="&resourcecontainer)
								
								Else
								
							End if
								
							commentdata("1RESETresourcecontainer="&resourcecontainer)
								
									Else
						
										resourcevaluesplita=Split(resourcevalue," /PS_")
										If UBound(resourcevaluesplita)>0 Then
											resourcevalue=resourcevaluesplita(0)
										End If
										commentdata("2resourcevalue="&resourcevalue)
										resourcecontainer=resourcecontainer&"@@"&Replace(newresourcename,"@@","")&"@@"&Replace(resourcevalue,"@@","")&"@@"
										commentdata("4"&resourcecontainersplit(0))
										commentdata("2SETresourcecontainer="&resourcecontainer)
										
									End if	
								
							End if
						End if
			
		End if
		
		
		If Left(mytxtline,4)="/PS_" Then
			
			resourcename=Replace(mytxtline,"/PS_","")
			resourcenamesplit=Split(resourcename,"findresource")
			
			If UBound(resourcenamesplit)>0 Then
			else
				resourcevalue=Mystream.ReadLine
				commentdata("1RESOURCENAME AND VALUE: "&resourcename&"-"&resourcevalue)
				resourcevalue=Replace(resourcevalue,"[/Separation","")
				resourcevaluesplit=Split(resourcevalue," CS_")
				resourcevalue=LTrim(resourcevaluesplit(0))
				commentdata("2"&resourceval&"-"&resourcevalue)
				resourcecontainersplit=Split(resourcecontainer,"@@"&resourcename&"@@")
				commentdata("1"&resourcecontainersplit)
				If UBound(resourcecontainersplit)>0 Then
				Else
					commentdata("1resourcevalue1:"&resourcevalue)
					resourcevaluesplita=Split(resourcevalue," /PS_")
					If UBound(resourcevaluesplita)>0 Then
							resourcevalue=resourcevaluesplita(0)
					End If	
					commentdata("1resourcevalue="&resourcevalue)
					resourcecontainer=resourcecontainer&"@@"&resourcename&"@@"&resourcevalue&"@@"
					commentdata("1qresourcecontainer="&resourcecontainer)
				End if
			End if
		End If
			
		'------------------------------------------------
		'WRITE LINES
		'------------------------------------------------
		
		Select Case Right(mytxtline,2)
			Case " m"	'moveto triggered
				remembertextlinetest
				circlestring=""
				commentdata("1___________________________Detect moveto "&mytxtline)
				If allowaxischange=True Then
					changeaxis(axisstring&"_"&Replace(Replace(mytxtline," m","")," ","_"))
					movetofunc(transx & " "&transy)
				else
						movetofunc(Replace(mytxtline," m",""))
				End if
				
				

				lastaction=""
				
			Case " l"	'lineto triggered
				remembertextlinetest
				circlestring=""
				commentdata("1Detect lineto "&mytxtline)
				lastaction=""
				If allowaxischange=True Then
					changeaxis(axisstring&"_"&Replace(Replace(mytxtline," l","")," ","_"))
					linetofunc(transx & " "&transy)
					else
					linetofunc(Replace(mytxtline," l",""))
				End if
				
				
			Case " c"	'curve triggered
				lastaction=""
  				'first check if circle
  				circletest=false
  				add2circlestring=""
				splitaa=Split(mytxtline," ")
				lastpntxori=lastpntx/convertpointstounits
				lastpntyori=lastpnty/convertpointstounits
							
				If allowaxischange=True Then
					changeaxis(axisstring&"_"&splitaa(0)&"_"&splitaa(1))
					x1ori=transx
					y1ori=transy
					
					splitaa(0)=transx
					splitaa(1)=transy
					
					changeaxis(axisstring&"_"&splitaa(2)&"_"&splitaa(3))
					x2ori=transx
					y2ori=transy
					
					splitaa(2)=transx
					splitaa(3)=transy
					
					changeaxis(axisstring&"_"&splitaa(4)&"_"&splitaa(5))
					x3ori=transx
					y3ori=transy
							
					splitaa(4)=transx
					splitaa(5)=transy			
					
						Else
							x1ori=splitaa(0)
							y1ori=splitaa(1)
							x2ori=splitaa(2)
							y2ori=splitaa(3)
							x3ori=splitaa(4)
							y3ori=splitaa(5)
				End if
				'check if one of the points is outside sheet
				insidesheet=True
				
				cpntdiff=lastcpnt-splitaa(4)
				If cpntdiff<0 Then
					cpntdiff=cpntdiff*-1
				End If
				
				If cpntdiff<60 Then
					circlearray="90"
					Else
					
						circlearray="45 45"
						If cpntdiff>300 Then
							circlearray="30 30 30"
							If cpntdiff>600 Then
								circlearray="15 15 15 15 15 15"
								If cpntdiff>800 Then
									circlearray="10 10 10 10 10 10 10 10 10"
									If cpntdiff>1600 Then
										circlearray="5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5"
										If cpntdiff>4000 Then
											circlearray="2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2"
										End if
									End if
								End if
							End if
						End If
				End if
				
				If extentionval = ".dxf" Then
					circlearray="90"
				End If
				
				splitcirclearray=Split(circlearray," ")
				splitcirclearraycount=UBound(splitcirclearray)
				x1=splitaa(0)*convertpointstounits
				y1=splitaa(1)*convertpointstounits
				x2=splitaa(2)*convertpointstounits
				y2=splitaa(3)*convertpointstounits
				x3=splitaa(4)*convertpointstounits
				y3=splitaa(5)*convertpointstounits
				insidesheet=True
				detectcirclesegments=True
		
				'-90 circle
				If 	detectcirclesegments<>False  Then
		
				If insidesheet<>False then
					
					If x2ori-x3ori<>0 then
						If Int(x1ori*cmfctr)=Int(lastpntxori*cmfctr) And Int(y2ori*cmfctr)=Int(y3ori*cmfctr) And Int((x2ori-x3ori)*cmfctr/1)=Int((lastpntyori-y1ori)*cmfctr/1) And Round(((lastpntxori-x3ori)/(x2ori-x3ori)),1)=1.8 Then
						
						
							If Int(lastpntyori*cmfctr)>Int(y3ori*cmfctr) Then
								If Int(lastpntxori*cmfctr)>Int(x3ori*cmfctr) Then 
									 If Int(x2ori*cmfctr)<>Int(x3ori*cmfctr) Then
									 	If extentionval <> ".dxf" Then
											circletest=True	
										End If
											circlecounter=0
											circlecontent=""
											Do While circlecounter<	splitcirclearraycount+1
												circlecontent=circlecontent&"AA "& x3 & " " & lastpnty &" "&"-"&splitcirclearray(circlecounter)&"@@@"
												circlecounter=circlecounter+1
											Loop
										End If
										
										commentdata("1C1-90")
										
										add2circlestring="da"
										add2circlestring2="ba"
									
								End if
							End if
						End If
					End If
					
					If lastpntxori-x1ori<>0 then
						If Int(x3ori*cmfctr)=Int(x2ori*cmfctr) And Int(lastpntyori*cmfctr)=Int(y1ori*cmfctr) And Int((lastpntxori-x1ori)*cmfctr/1)=Int((y3ori-y2ori)*cmfctr/1) And Round(((lastpntxori-x3ori)/(lastpntxori-x1ori)),1)=1.8 Then
							If Int(lastpntxori*cmfctr)>Int(x3ori*cmfctr) Then
								If Int(y3ori*cmfctr)>Int(lastpntyori*cmfctr) Then
									If Int(y3ori*cmfctr)<>Int(y2ori*cmfctr) Then
										If extentionval <> ".dxf" Then
											circletest=True
											circlecontent=""
												circlecounter=0
											Do While circlecounter<	splitcirclearraycount+1
												circlecontent=circlecontent&"AA "& lastpntx & " " & y3 &" "&"-"&splitcirclearray(circlecounter)&"@@@"
												circlecounter=circlecounter+1
											loop
										End if
										commentdata("1C2-90")
										add2circlestring="ab"
										add2circlestring2="cb"
										commentdata("1BECAUSE "&(x3ori*cmfctr)&"="&(x2ori*cmfctr)&" And "&(lastpntyori*cmfctr)&"="&(y1ori*cmfctr)&" And "&((lastpntxori-x1ori)*cmfctr/1)&"="&((y3ori-y2ori)*cmfctr/1)&" And "&Round(((lastpntxori-x3ori)/(lastpntxori-x1ori)),1)&"=1.8 Then")
					
									End If
								End if
							End If
						End if
					End If
					
					If x3ori-x2ori<> 0 Then
					commentdata("1C31?If " &Int(x1ori*cmfctr)&"="&Int(lastpntxori*cmfctr)&" And "&Int(y3ori*cmfctr)&"="&Int(y2ori*cmfctr) &"And"& Int((x3ori-x2ori)*cmfctr/1)&"="&Int((y1ori-lastpntyori)*cmfctr/1)&" And "&Round(((x3ori-lastpntxori)/(x3ori-x2ori)),1)&"=1.8 Then")
				
						If Int(x1ori*cmfctr)=Int(lastpntxori*cmfctr) And Int(y3ori*cmfctr)=Int(y2ori*cmfctr) And Int((x3ori-x2ori)*cmfctr/1)=Int((y1ori-lastpntyori)*cmfctr/1) And Round(((x3ori-lastpntxori)/(x3ori-x2ori)),1)=1.8 Then
							If Int(x3ori*cmfctr)>Int(lastpntxori*cmfctr) Then
								If Int(y3ori*cmfctr)>Int(lastpntyori*cmfctr) Then
									If Int(x3ori*cmfctr)<>Int(x2ori*cmfctr) Then
										If extentionval <> ".dxf" Then
											circletest=True
											circlecontent=""
											circlecounter=0
											Do While circlecounter<	splitcirclearraycount+1
												circlecontent=circlecontent&"AA "& x3 & " " & lastpnty &" "&"-"&splitcirclearray(circlecounter)&"@@@"
												circlecounter=circlecounter+1
											Loop
										End if
										commentdata("1C3-90")
										add2circlestring="bc"
										add2circlestring2="dc"
									End if
								End If
							End If
						End if
					End If		
				
					
					If x1ori-lastpntxori<>0 then
						If Int(x3ori*cmfctr)>Int(lastpntxori*cmfctr) Then
							If Int(lastpntyori*cmfctr)>Int(y3ori*cmfctr) Then
								If Int(y3ori*cmfctr)<>Int(y2ori*cmfctr) then
									If Int(x2ori*cmfctr)=Int(x3ori*cmfctr) And Int(lastpntyori*cmfctr)=Int(y1ori*cmfctr) And Int((x1ori-lastpntxori)*cmfctr/1)=Int((y2ori-y3ori)*cmfctr/1) And Round(((x3ori-lastpntxori)/(x1ori-lastpntxori)),1)=1.8 Then
										If extentionval <> ".dxf" Then
											circletest=True
										
											circlecontent=""
											circlecounter=0
											Do While circlecounter<	splitcirclearraycount+1
												circlecontent=circlecontent&"AA "& lastpntx & " " & y3 &" "&"-"&splitcirclearray(circlecounter)&"@@@"
												circlecounter=circlecounter+1
											Loop	
											End if
										commentdata("1C4-90")
										add2circlestring="cd"
										add2circlestring2="ad"	
									End If
								End If
							End if
						End If		
					End if		
	
					'+90 circle
					If x1ori-lastpntxori<>0 then
						If Int(lastpntyori*cmfctr)= Int(y1ori*cmfctr) And Int(x2ori*cmfctr)= Int(x3ori*cmfctr) And Int((x1ori-lastpntxori)*cmfctr/1)=Int((y3ori-y2ori)*cmfctr/1) And Round(((x3ori-lastpntxori)/(x1ori-lastpntxori)),1)=1.8 Then
						
							If Int(x3ori*cmfctr)>Int(lastpntxori*cmfctr) Then
								If Int(y3ori*cmfctr)>Int(lastpntyori*cmfctr) Then
									If Int(y3ori*cmfctr)<>Int(y2ori*cmfctr) Then
										If extentionval <> ".dxf" Then
											circletest=True
									End if
											circlecontent=""
											circlecounter=0
											Do While circlecounter<	splitcirclearraycount+1
												circlecontent=circlecontent&"AA "& lastpntx & " " & y3 &" "&"+"&splitcirclearray(circlecounter)&"@@@"
												circlecounter=circlecounter+1
											Loop
											End if
											commentdata("1C1+90")
											add2circlestring="he"
											add2circlestring2="fe"
									End if
								End if
							End if
						End If
					End if
					
					'+90 circle
					If x3ori-x2ori<>0 then
						If Int(y3ori*cmfctr)= Int(y2ori*cmfctr) And Int(lastpntxori*cmfctr)= Int(x1ori*cmfctr) And Int((x3ori-x2ori)*cmfctr/1)=Int((lastpntyori-y1ori)*cmfctr/1) And Round(((x3ori-lastpntxori)/(x3ori-x2ori)),1)=1.8 Then
							
							If Int(x3ori*cmfctr)>Int(lastpntxori*cmfctr) Then
								If Int(lastpntyori*cmfctr)>Int(y3ori*cmfctr) Then 
									If Int(x3ori*cmfctr)<>Int(x2ori*cmfctr) Then
										If extentionval <> ".dxf" Then
											circletest=True
											circlecontent=""
											circlecounter=0
											Do While circlecounter<	splitcirclearraycount+1
												circlecontent=circlecontent&"AA "& x3 & " " & lastpnty &" "&"+"&splitcirclearray(circlecounter)&"@@@"
												circlecounter=circlecounter+1
											Loop
										
										End if
										commentdata("1C2+90")
										add2circlestring="ef"
										add2circlestring2="gf"
									End If
								End If
							End if
						
						End If
					End if
					
			
					If lastpntxori-x1ori <> 0 then
						If Int(lastpntyori*cmfctr)= Int(y1ori*cmfctr) And Int(x3ori*cmfctr)= Int(x2ori*cmfctr) And Int((lastpntxori-x1ori)*cmfctr/1)=Int((y2ori-y3ori)*cmfctr/1) And Round(((lastpntxori-x3ori)/(lastpntxori-x1ori)),1)=1.8 Then
						commentdata("1If "&(lastpntyori*cmfctr)&"="& (y1ori*cmfctr)&" And "&(x3ori*cmfctr)&"="& (x2ori*cmfctr)&" And "&((lastpntxori-x1ori)*cmfctr/100)&"="&((y2ori-y3ori)*cmfctr/100)&" And "&Round(((lastpntxori-x3ori)/(lastpntxori-x1ori)),1)&"=1.8 Then")
					
							On Error Resume next
							If Int(lastpntxori*cmfctr)>Int(x3ori*cmfctr) Then
							
								commentdata("1C3+90?")
									If Int(lastpntyori*cmfctr)>Int(y3ori*cmfctr) Then
										If Int(y3ori*cmfctr)<>Int(y2ori*cmfctr) then
										'	commentdata("1"&lastpntx>x3 & lastpnty>y3)
											If extentionval <> ".dxf" Then
												circletest=True
												circlecontent=""
												circlecounter=0
												Do While circlecounter<	splitcirclearraycount+1
													circlecontent=circlecontent&"AA "& lastpntx & " " & y3 &" "&"+"&splitcirclearray(circlecounter)&"@@@"
													circlecounter=circlecounter+1
												Loop
											End if
										
											
											commentdata("1C3+90")
											add2circlestring="fg"
											add2circlestring2="hg"
										End If
									End if
							End if
						End If
					End if
					
					If x2ori-x3ori <>0 then
						If Int(y2ori*cmfctr)= Int(y3ori*cmfctr) And Int(lastpntxori*cmfctr)= Int(x1ori*cmfctr) And Int((x2ori-x3ori)*cmfctr/1)=Int((y1ori-lastpntyori)*cmfctr/1) And Round(((lastpntxori-x3ori)/(x2ori-x3ori)),1)=1.8 Then
							If Int(lastpntxori*cmfctr)>Int(x3ori*cmfctr) Then
								If Int(y3ori*cmfctr)>Int(lastpntyori*cmfctr) Then
									If Int(x3ori*cmfctr)<>Int(x2ori*cmfctr) then
										commentdata(lastpntx>x3 & y3>lastpnty)
										If extentionval <> ".dxf" Then
											circletest=True
										
											circlecontent=""
											circlecounter=0
											Do While circlecounter<	splitcirclearraycount+1
												circlecontent=circlecontent&"AA "& x3 & " " & lastpnty &" "&"+"&splitcirclearray(circlecounter)&"@@@"
												circlecounter=circlecounter+1
											Loop
										End if
										
										commentdata("1C4+90")
										add2circlestring="gh"
										add2circlestring2="eh"
									End If
								End If
							End if
						
						End If	
					End if
		
				End if
			
				If add2circlestring<>"" Then
					If circlestring<>"" Then
						If Right(circlestring,1)=Left(add2circlestring,1) Or Right(circlestring,1)=Left(add2circlestring2,1) Then
							circlestring=circlestring&Right(add2circlestring,1)
							Else
								circlestring=""	'not a circle
						End If
						Else
							circlestring=circlestring&Right(add2circlestring,1)	'first instance of circle
					End If
					Else
						circlestring=""	'not a circle
					
				End If
				If Len(circlestring)=4 Then
					commentdata("1Detect a perfect circle: "&circlestring)
					circletest=True
				End If
				
				
				Select Case extentionval
					Case ".xml"
							circletest=False	'xml doesn't support circles
					Case ".gbr"
							circletest=False	'gbr doesn't support circles
				End select
				
				
				
				
				If circletest=True And startopos<>True And oposiswritten = True Then
					commentdata("1Detect Circle "&mytxtline)
						
						lastpntx=x3
						lastpnty=y3
						
							commentdata("1"&"h lastpntx="&lastpntx&"_"&"lastpnty="&lastpnty)
						
						splitcirclecontent=Split(circlecontent,"@@@")
						splitcirclecontentcount=UBound(splitcirclecontent)
						circcounter=0
						Do While circcounter<splitcirclecontentcount+1
							If splitcirclecontent(circcounter)<>"" then
								myarray(myarraycounter)=splitcirclecontent(circcounter)
								myarraycounter=myarraycounter+1
							End if
						circcounter=circcounter+1
						loop
						circlearray=""
						circlecontent=""
						commentdata("1remembertextline: RESET")
					remembertextline=""
					circletest=true
				Else
					commentdata("1NOT CIRCLE (YET?)---------------------------------------")
					commentdata("7Detect bezier "&mytxtline)
					If extentionval <> ".dxf" Then
					
						If allowaxischange=True Then
							curvetofunc(x1ori&" "&y1ori&" "&x2ori&" "&y2ori&" "&x3ori&" "&y3ori)
				
							else
								curvetofunc(Replace(mytxtline," c",""))
						
						End if
					
					
						Else
						commentdata("1DXF circlestring="&circlestring)
						
							If circlestring="" then
								remembertextlinetest
								curvetofunc(Replace(mytxtline," c",""))
								
								Else
									If remembertextline<>"" Then
										remembertextline=remembertextline&"%%"
									End if
									remembertextline=remembertextline&mytxtline
									commentdata("1remembertextline: UPDATE:"&remembertextline)
									splitaa=Split(Replace(mytxtline," c","")," ")
									
									
									If supportbeziers=True then
									
									lastpntx=splitaa(4)*convertpointstounits
									lastpnty=splitaa(5)*convertpointstounits
									commentdata("1"&"g lastpntx="&lastpntx&"_"&"lastpnty="&lastpnty)
									End if
									
									
									
										
							End If
					End if
				End If
		End Select
		
		'------------------------------------------------
		'WRITE rectangular
		'------------------------------------------------
		
		If Right(mytxtline,3)=" re" Or Right(mytxtline,4)=" re " Then
			remembertextlinetest
			commentdata("2Detectrect")
			lastaction="rectangular"
			mytxtlineresplit=Split(mytxtline," ")
			If UBound(mytxtlineresplit)=5 Then
			commentdata("4Detect rectangle "&mytxtline)
				movetofunc(mytxtlineresplit(0)&" "&mytxtlineresplit(1))
				linetofunc(mytxtlineresplit(2)&" "&mytxtlineresplit(1))	
				linetofunc(mytxtlineresplit(2)&" "&mytxtlineresplit(3))	
				linetofunc(mytxtlineresplit(0)&" "&mytxtlineresplit(3))	
				linetofunc(mytxtlineresplit(0)&" "&mytxtlineresplit(1))
					Else
					commentdata("7Defect "&UBound(mytxtlineresplit)&" rectangle "&mytxtline)
			
			End If
			Else
			lastaction=""
		End if	
							
	Loop
	MyStream.close

End If	


Function remembertextlinetest
	If remembertextline<>"" Then
						commentdata("1remembertextline: "&remembertextline)
							tlcounter=0
							splitremembertextline=Split(remembertextline,"%%")
							Do While tlcounter<UBound(splitremembertextline)+1
							curvetofunc(Replace(splitremembertextline(tlcounter)," c",""))
							
							tlcounter=tlcounter+1
							loop
						End if
						remembertextline=""
End function


'------------------------------------------------
'FUNCTION To Rotate An Element
'------------------------------------------------

Sub rotateelement(elementxy)
	commentdata("1startRotateElement")
	elementxysplit=Split(elementxy," ")
	commentdata("1markrotation="&markrotation)
	Select case markrotation 
		case "-3"
			add2textcontent=elementxysplit(1)*convertpointstounits & " " & -elementxysplit(0)*convertpointstounits
				lastpntx=elementxysplit(1)*convertpointstounits
				lastpnty=-elementxysplit(0)*convertpointstounits
		Case "-1"
			add2textcontent=-elementxysplit(1)*convertpointstounits & " " & elementxysplit(0)*convertpointstounits
		
			lastpntx=-elementxysplit(1)*convertpointstounits
			
			lastpnty=elementxysplit(0)*convertpointstounits
		
		Case "-2"
			add2textcontent=-elementxysplit(0)*convertpointstounits & " " & -elementxysplit(1)*convertpointstounits
			lastpntx=-elementxysplit(0)*convertpointstounits
			lastpnty=-elementxysplit(1)*convertpointstounits
		Case else
			add2textcontent=elementxysplit(0)*convertpointstounits & " " & elementxysplit(1)*convertpointstounits
			lastpntx=elementxysplit(0)*convertpointstounits
			lastpnty=elementxysplit(1)*convertpointstounits
	End Select
		commentdata("1"&"f lastpntx="&lastpntx&"_"&"lastpnty="&lastpnty)
	commentdata("1EndRotateElement")

End sub


'------------------------------------------------
'FUNCTION movetofunc
'------------------------------------------------

Sub movetofunc(aa)
	splitaa=Split(aa," ")
	rotateelement(splitaa(0)&" "&splitaa(1))
	textcontent="PU "&add2textcontent
	insidesheet=True
	
	If insidesheet=True then
		myarray(myarraycounter)=textcontent
		
		commentdata("1"&"MOVETOFUNCTION: "&textcontent)
		
		myarraycounter=myarraycounter+1
		''pointoutsidesheet=""
		Else
		
		''pointoutsidesheet=textcontent
		
	End if
	textcontent=""
End Sub
'------------------------------------------------
'FUNCTION linetofunc
'------------------------------------------------
Sub linetofunc(aa)
	commentdata("1startlinetofunc")
	commentdata("2aa:"&aa)
	splitaa=Split(aa," ")
	rotateelement(splitaa(0)&" "&splitaa(1))
	splitaa=Split(add2textcontent," ")
	newpointx=splitaa(0)
	newpointy=splitaa(1)
	commentdata("1newpointx:"&newpointx)
	commentdata("1newpointy:"&newpointy)
	
	Err.Clear
	On Error Resume next
	commentdata("2dashonvalue:"&dashon)
	commentdata("2dashoffvalue:"&dashoff)
	
	If dashon<>"" And dashon<>0 And dashoff<> "" And dashoff<> 0 Then	'In case of a dashed line
			commentdata("2dashon")
			dashonunits=dashon*convertpointstounits
			dashoffunits=dashoff*convertpointstounits
			If (newpointx-lastpntx)=0 Then
				dsd=pivalue/2
				else
					dsd=Atn((newpointy-lastpnty)/(newpointx-lastpntx))  'dsd=angle of line
			End If	
			If (newpointy-lastpnty)=0 Then
				dsf=newpointx-lastpntx
					Else
				dsf=(newpointy-lastpnty)/Sin(dsd)	'dsf=length of line
			End if
			lengthline=0
			Do While lengthline<dsf
				'commentdata("2"&lengthline&"_"&dsf)
				If lengthline+dashonunits>dsf Then
					curdashonunits=dsf-lengthline
					Else
					curdashonunits=dashonunits
				End if
				dsbx=(Cos(dsd)*curdashonunits)+lastpntx
				dsby=(SIN(dsd)*curdashonunits)+lastpnty
				lengthline=lengthline+curdashonunits
				textcontent="PD "& dsbx & " " & dsby
				lastpntx=dsbx
				lastpnty=dsby
				myarray(myarraycounter)=textcontent
				myarraycounter=myarraycounter+1
				textcontent=""
				If lengthline+dashoffunits>dsf Then
					curdashoffunits=dsf-lengthline
					Else
					curdashoffunits=dashoffunits
				End if
				dsbx=(Cos(dsd)*curdashoffunits)+lastpntx
				dsby=(SIN(dsd)*curdashoffunits)+lastpnty
				lengthline=lengthline+curdashoffunits			
				textcontent="PU "& dsbx & " " & dsby
				lastpntx=dsbx
				lastpnty=dsby
				
					commentdata("1"&"d lastpntx="&lastpntx&"_"&"lastpnty="&lastpnty)
				
				myarray(myarraycounter)=textcontent
				myarraycounter=myarraycounter+1
				textcontent=""		
			loop
		
	
			Else	'In case line is not dashed
						commentdata("2nodash")
						textcontent="PD "& add2textcontent
						commentdata("1textcontent="&textcontent)
						insidesheet=True
						myarray(myarraycounter)=textcontent
						myarraycounter=myarraycounter+1
						''pointoutsidesheet=""
						textcontent=""
	End if
	
End sub


Sub variablegrain(lengthtest)
	If lengthtest>(distancestartstop) Then
					actualgrainunits=grainunits
						Else
						If lengthtest>(distancestartstop/2) Then
						actualgrainunits=grainunits*1
						Else
						actualgrainunits=grainunits*1
						End if
	End if
End sub




Sub calcdistbetweenpnts
	If Kx-oldtargetx=0 Then
		anglebetweenpnts=pivalue/2
			Else
				anglebetweenpnts=Atn((Ky-oldtargety)/(Kx-oldtargetx))
	End if
				
	distbetwpnts=Abs((Kx-oldtargetx)/cos(anglebetweenpnts))	'lookup distance between previous point and current point
End sub



Sub curvetofunc(aa)
	prevKx=lastpntx
	prevKy=lastpnty
	splitaa=Split(aa," ")

	If supportbeziers=True Then
		If UBound(splitaa)>4 Then
			textcontent = "BZ "& splitaa(0)*convertpointstounits & " " & splitaa(1)*convertpointstounits & " " & splitaa(2)*convertpointstounits & " " & splitaa(3)*convertpointstounits & " " & splitaa(4)*convertpointstounits & " " & splitaa(5)*convertpointstounits &Chr(10)
			myarray(myarraycounter)=textcontent
			myarraycounter=myarraycounter+1
			textcontent=""
		End if
				else
					commentdata("8STARTBEZIER")
					beziervals=lastpntx&"_"&lastpnty&"_"&splitaa(0)*convertpointstounits&"_"&splitaa(1)*convertpointstounits&"_"&splitaa(2)*convertpointstounits&"_"&splitaa(3)*convertpointstounits&"_"&splitaa(4)*convertpointstounits&"_"&splitaa(5)*convertpointstounits
					
					If ((splitaa(4)*convertpointstounits)-lastpntx)=0 Then
						startstopangle=pivalue/2
						Else
							startstopangle=Atn(((splitaa(5)*convertpointstounits)-lastpnty)/((splitaa(4)*convertpointstounits)-lastpntx))
					End If
					distancestartstop=((splitaa(4)*convertpointstounits)-lastpntx)/cos(startstopangle)
	
					variablegrain(P)
					
					pc=0.25
					oldtargetx=lastpntx		'set the start point
					oldtargety=lastpnty
					
					intermediatepoint()		'lookup coordinates 0.25 point
				
					calcdistbetweenpnts	'lookup distance between previous point and 0.25 point
					writeintermed
					
					variablegrain(P+V)
				
					pc=0.5
					
					oldtargetx=lastpntx
					oldtargety=lastpnty
				
					intermediatepoint()
				
					calcdistbetweenpnts
					
					writeintermed
				
					
					variablegrain(P+V)
					
					commentdata("7PC75")
					pc=0.75
					
					oldtargetx=lastpntx
					oldtargety=lastpnty
					
					intermediatepoint()
					
					calcdistbetweenpnts
				
					commentdata("7PC="&pc)
					writeintermed
				
					
					variablegrain(V)
					
					
					pc=1
					
					oldtargetx=lastpntx
					oldtargety=lastpnty
					
					Kx=splitaa(4)*convertpointstounits
					Ky=splitaa(5)*convertpointstounits
				
					calcdistbetweenpnts
		
				
					commentdata("8Distance between points 0.75 and 1.00= "&distbetwpnts&" units")
					writeintermed
			
					
					
	End if
	
	lastpntx=splitaa(4)*convertpointstounits
	lastpnty=splitaa(5)*convertpointstounits
	commentdata("1"&"c lastpntx="&lastpntx&"_"&"lastpnty="&lastpnty)
End sub



If textatend<>"" Then
	writefiles(textatend&"#@#1")
End if


Select Case extentionval
	Case ".cf2"
		writefiles("END"&Chr(10)&"#@#1")
		writefiles("$EOF"&Chr(10)&"#@#1")
	
	
	Case ".dxf"	
		writefiles("  0"&Chr(10)&"#@#1")
		writefiles("ENDSEC"&Chr(10)&"#@#1")
		writefiles("  0"&Chr(10)&"#@#1")
		writefiles("EOF"&"#@#1")
	Case ".gbr"
		writefiles("M15*"&Chr(10)&"#@#1")
		writefiles("M0*"&"#@#1")
		
	Case Else
		If cutter="konaal4" Then
			writefiles("PA;"&"#@#1")
			writefiles("PU0,0;"&"#@#1")
			writefiles("SP0;"&"#@#1")
			If cutteroption="AL4" Then
			writefiles("AL4,2;"&"#@#1")
			End if
			else
			writefiles("PU;"&"#@#1")
		End if
End Select

Select Case cutter
	Case "summa"
		If cutoffsumma=True Then
	
			writefiles("EC;PG;"&"#@#1")
			Else
				writefiles("PG;"&"#@#1")
		End If
	Case "roland"
		writefiles("!PG;"&"#@#1")
End Select


'PrettyPrint function
function pretty_print
					
	Set xmlStream = CreateObject("ADODB.STREAM")
	xmlStream.Open

	xmlStream.Charset = "utf-8"
	On Error Resume next
	set reader = CreateObject("Msxml2.SAXXMLReader.4.0")
	
	If err.number>0 then
	set reader = CreateObject("Msxml2.SAXXMLReader.6.0")
	set writer = CreateObject("Msxml2.MXXMLWriter.6.0")   
	Else
		set writer = CreateObject("Msxml2.MXXMLWriter.4.0")  
	End If
	writer.output = xmlStream    
	writer.indent = true
	writer.standalone = true
    reader.putProperty "http://xml.org/sax/properties/lexical-handler", writer

	writer.encoding = "utf-8"
	reader.contentHandler = writer            
	reader.parseURL(prettyfile)

	writer.flush

	xmlStream.SaveToFile prettyfile, 2
					
end function



If extentionval=".xml" Then
	xmlDoc.save(tempfolderroot&finaloutputfile& extentionval)
	prettyfile=tempfolderroot&finaloutputfile& extentionval
	pretty_print
	
	If exportdebugfiles=True Then
		xmlDoc.save(debugfilefinal)
		prettyfile=debugfilefinal
		pretty_print	
	End if	
			
Else



Select Case extentionval

	Case ".dxf"	
		If dxfheader=True Then
		hpglfile.Close
	
		Set f = fso.OpenTextFile(tempfolderroot&finaloutputfile& extentionval, ForReading)
		
   		ReadAllTextFile =   f.ReadAll
		f.close
	
		Set hpglfile = fso.OpenTextFile(tempfolderroot&finaloutputfile& extentionval, ForWriting, True)


		
			writethedxfheader
			   		hpglfile.Write ReadAllTextFile
		End if
End select

hpglfile.Close

End If
If postfilename="0" Then
	hpglfile5.Close
End if

If exportdebugfiles=True Then
	If extentionval<>".xml" Then
		hpglfiledebug.Close
	End if
	hpglfiledebug2.Close
	If cutter="summa" then
		hpglfiledebugnoopos.Close
	End If
	If cutter="konaal4" Then
		hpglfiledebugnoal4.Close
	End if
	If postfilename="0" Then
		hpglfiledebugnoopos5.Close
		hpglfile5debug.close
	End if
End if


If usetempfolder=True Then

	If fso.FileExists(tempfolderroot&finaloutputfile& extentionval) Then
		If fso.FileExists(outputfolderroot&finaloutputfile& extentionval) Then
			Err.clear
			On Error Resume next
			fso.DeleteFile(outputfolderroot&finaloutputfile& extentionval)
			If Err.Number>0 Then
				posterror(Err.Description)
				WScript.Quit 2
			End if
		End if
		Err.Clear
		

		 filesplit=Split(xmloutputfile,";")

		If UBound(filesplit) > 0 Then
			fcounter=1
			Do While fcounter<UBound(filesplit)+1
				Set MyFileaaaa = fso.GetFile(tempfolderroot&finaloutputfile& extentionval)
				err.Clear
				On Error Resume next
				MyFileaaaa.Copy filesplit(fcounter)&"\"&finaloutputfile& extentionval
				If Err.Number<>0 Then
				
						stderr.WriteLine "[EPSConverter] SNO: fso.MoveFile FROM "&tempfolderroot&finaloutputfile& extentionval&" TO "& filesplit(fcounter)&"\"&finaloutputfile& extentionval &" FAILS: "&Err.Description
						fso.DeleteFile tempfolderroot&finaloutputfile& extentionval
						WScript.Quit 2
				End If
				fcounter=fcounter+1
			loop
		
       	End if
		
		On Error Resume Next
		fso.MoveFile tempfolderroot&finaloutputfile& extentionval, outputfolderroot
		If Err.Number<>0 Then
			stderr.WriteLine "[EPSConverter] SNO: fso.MoveFile FROM "&tempfolderroot&finaloutputfile& extentionval&" TO "& filesplit(fcounter)&"\"&finaloutputfile& extentionval &" FAILS: "&Err.Description
			
			
			fso.DeleteFile tempfolderroot&finaloutputfile& extentionval
			fso.DeleteFile epsfilelocation
			
			WScript.Quit 2
		End If
		
	
		
			Else
				stderr.WriteLine "[EPSConverter] SNO: Not possible to move "&tempfolderroot&finaloutputfile& extentionval & " to "&outputfolderroot
				WScript.Quit 2
	End If 

	If postfilename="0" Then
		If fso.FileExists(filename5) Then
			If fso.FileExists(outputfolderroot&finalfilename5) Then
				Err.Clear
				On Error Resume next
				fso.DeleteFile(outputfolderroot&finalfilename5)
							If Err.Number>0 Then
				posterror(Err.Description)
				WScript.Quit 2
			End if
		End If
		
				 filesplit=Split(xmloutputfile,";")

		If UBound(filesplit) > 0 Then
			fcounter=1
			Do While fcounter<UBound(filesplit)+1
				Set MyFileaaaa = fso.GetFile(filename5)
				err.Clear
				On Error Resume next
				MyFileaaaa.Copy filesplit(fcounter)&"\"&finaloutputfile5& extentionval
				If Err.Number<>0 Then
				posterror("File cannot be moved to "& filesplit(fcounter)&"\"&finaloutputfile& extentionval &"Error: "&Err.Description&". Check if Asanti server has access to this location.")
				
				'posterror("fso.MoveFile FROM "&tempfolderroot&finaloutputfile5& extentionval&" TO "& filesplit(fcounter)&"\"&finaloutputfile& extentionval &"FAILS: "&Err.Description)
					err.clear
				End If
			fcounter=fcounter+1
			loop
		
       	End if
		
		fso.MoveFile filename5, outputfolderroot
		
		
			
		
		End if
		
	End if

End if

If usetempfolder=True Then
	On Error Resume next
	
err.Clear
	fso.DeleteFile epsfilelocation
	On Error Resume next
	If err.number>0 then
	posterror("Cannot delete "&epsfilelocation)
	err.clear
	End if
End if


If errorval<>"" Then

Set errfile = fso.CreateTextFile(errorfile, True)
errfile.Write errorval
errfile.close
End if

Function writeintermed

	targetx=Kx
	targety=Ky
	testpc=pc
	intermediatepoints=Round((distbetwpnts/actualgrainunits),0)
	If intermediatepoints=0 Then
		intermediatepoints=1
	End if
	stepdistance=0.25/intermediatepoints
	positionpointer=pc-0.25+stepdistance

	Do While positionpointer<testpc-stepdistance
		pc=positionpointer
		intermediatepoint()
		rotateelement(Kx/convertpointstounits&" "&ky/convertpointstounits)
		textcontent="PD "& add2textcontent
		
		myarray(myarraycounter)=textcontent
		textcontent=""
		myarraycounter=myarraycounter+1
		positionpointer=positionpointer+stepdistance
	loop

	rotateelement(targetx/convertpointstounits&" "&targety/convertpointstounits)
	
	textcontent="PD "& add2textcontent

	myarray(myarraycounter)=textcontent
	textcontent=""
	myarraycounter=myarraycounter+1
	
	prevKx=targetx
	lastpntx=targetx
	Kx=targetx
	
	prevKy=targety
	lastpnty=targety
	Ky=targety
	commentdata("1"&"b lastpntx="&lastpntx&"_"&"lastpnty="&lastpnty)

End function




Function intermediatepoint

	beziervalssplit=Split(beziervals,"_")
	Startx=beziervalssplit(0)
	starty=beziervalssplit(1)
	
	commentdata("2"&Startx&"_"&starty&"_"&Ax&"_"&Ay&"_"&Bx&"_"&By&"_"&Lx&"_"&Ly&"_"&pc)

	Ax=beziervalssplit(2)
	Ay=beziervalssplit(3)
	Bx=beziervalssplit(4)
	By=beziervalssplit(5)
	Lx=beziervalssplit(6)
	Ly=beziervalssplit(7)
	
	commentdata("1"&Startx&"_"&starty&"_"&Ax&"_"&Ay&"_"&Bx&"_"&By&"_"&Lx&"_"&Ly&"_"&pc)

	'ANGLE calculation O
	If Round((Ax-Startx),5)=0 Then
		O=pivalue/2
			Else
				O=Atn((Ay-starty)/(Ax-Startx))
	End if
	'commentdata("1"&"O="&O)


	'commentdata("1"&Round((Ax-Startx),3))
	If Round((Ax-Startx),3)=0 Then
			If Round((Ay-starty),3)=0 Then
				P=0
					Else
					P=(Ay-Starty)
			End if
			Else
				If Round((Ay-starty),3)=0 Then
					P=(Ax-Startx)
					else
					P=(Ax-Startx)/Cos(O)
				End if
	End If
	
	Cx=(P*pc)*COS(O)+Startx
	Cy=SIN(O)*P*pc+starty
	
	'commentdata("1"&"Cx="&Cx&" Cy="&Cy)
	
	R=Bx-Ax
	S=By-Ay
	
	'ANGLE calculation T
	If R=0 Then
		T=pivalue/2
			Else
				T=Atn(S/R)
	End if
	'commentdata("1"&"T="&T)
	If Round(R,3)=0 Then
		If Round(S,3)=0 Then
		F=0
		else
		F=S
		End if
			Else
				If Round(S,3)=0 Then
					F=R
						else
							F=R/COS(T)
				End if
	End if
	
	Hx=(COS(T)*F*pc)+Ax
	Hy=(SIN(T)*F*pc)+Ay
		''	commentdata("1"&"Hx="&Hx&" Hy="&Hy)
	'ANGLE calculation Q	
	If Round((Bx-Lx),5)=0 then
		Q=pivalue/2
			Else	
				Q=Atn((By-Ly)/(Bx-Lx))
	End If
	'commentdata("1"&"Q="&Q)
	If Round((Bx-Lx),3)=0 Then
		If Round((By-Ly),3)=0 Then
		V=0
		else
		V=(By-Ly)
		End if
		
			Else
				If Round((By-Ly),3)=0 Then
				V=(Bx-Lx)
					else
						V=(Bx-Lx)/COS(Q)
				End if
	End if	
			
	Dx=(V*(1-pc)*COS(Q))+Lx
	Dy=(SIN(Q)*V*(1-pc))+Ly
		''commentdata("1"&"Dx="&Dx&" Dy="&Dy)
	'ANGLE calculation U
	If Round((Hx-Cx),5)=0 Then
		U=pivalue/2
			else
				U=Atn((Hy-Cy)/(Hx-Cx))
	End If
		''commentdata("1"&"U="&U)
	If Round((Hx-Cx),3)=0 Then
		If Round((Hy-Cy),3)=0 Then
			Eleng=0
				else
					Eleng=(Hy-Cy)
		End if
		
			Else
			If Round((Hy-Cy),3)=0 Then
			Eleng=(Hx-Cx)
			else
				Eleng=(Hx-Cx)/COS(U)
			End if
	End if
	
	Ix=(Eleng*pc*COS(U))+Cx
	Iy=(SIN(U)*Eleng*pc)+Cy
''	commentdata("1"&"Ix="&Ix&" Iy="&Iy)

	'ANGLE calculation Z	
	If Round((Dx-Hx),5)=0 Then
		Z=pivalue/2
			Else
				Z=Atn((Hy-Dy)/(Dx-Hx))
	End If
	''commentdata("1"&"Z="&Z)
	
	If Round((Dx-Hx),3)=0 Then
		If Round((Dy-Hy),3)=0 Then
			If pc="0.5" Then
				commentdata("7G=0")
			End if
			G=0
			else
			G=(Dy-Hy)
			
			If pc="0.5" Then
				''commentdata("7G=Dy-Hy="&Dy&"-"&Hy&"="&Dy-Hy)
			End if
			
		End if
	
			Else
			If Round((Dy-Hy),3)=0 Then
			G=(Dx-Hx)
			else
			G=(Dx-Hx)/COS(Z)
			End if
	End If
	''commentdata("1"&"G="&G)

	Jx=(COS(Z)*G*(pc))+Hx
	
	If Round((Hx-Dx),5)=0 Then
		If Hy<Dy Then
			Jy=Hy+(G*pc)
				else
					Jy=Hy-(G*pc)
		End if
		else
			Jy=Hy-(SIN(Z)*G*(pc))
	End If

	'ANGLE calculation e		
	If Round((Jx-Ix),5)=0 Then
		e=pivalue/2
			else
				e=Atn((Jy-Iy)/(Jx-Ix))
	End if

	If Round((Jx-Ix),3)=0 Then
		If Round((Jy-Iy),3)=0 Then
			d=0
				else
				d=(Jy-Iy)
		End if
		
			Else
			If Round((Jy-Iy),3)=0 Then
				d=(Jx-Ix)
				else
					d=(Jx-Ix)/COS(e)
			End if
	End If
	
	Kx=(COS(e)*d*pc)+Ix
	Ky=(SIN(e)*d*pc)+Iy

	''commentdata("1"&"Kx="&Kx&"_"&"Ky="&Ky)
	prevKx=lastpntx
	lastpntx=Kx
	prevKy=lastpnty
	lastpnty=Ky
	
	''commentdata("1"&"lastpntx="&lastpntx&"_"&"lastpnty="&lastpnty)

End Function


Function commentdata(codata)	
	If IsNumeric(Left(codata,1))=True then
		If CInt(Left(codata,1))<commentslevel+1 Then
			writefiles("CO "&Mid(codata,2,((Len(codata))-1))&";"&Chr(10)&"#@#1")
		End If		
		If commentslevel=0 And Left(codata,1)="1" Then
				writefiles("CO "&Mid(codata,2,((Len(codata))-1))&";"&Chr(10)&"#@#3")
		End if
		
	End if
End Function

Function writethedxfheader
	writefiles("999"&Chr(10)&"#@#1")
	writefiles("dxfrw 0.5.10"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("SECTION"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("HEADER"&Chr(10)&"#@#1")
	writefiles("9"&Chr(10)&"#@#1")
	writefiles("$ACADVER"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("AC1021"&Chr(10)&"#@#1")
	writefiles("9"&Chr(10)&"#@#1")
	writefiles("$HANDSEED"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("20000"&Chr(10)&"#@#1")
	
	writefiles("$INSUNITS"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("4"&Chr(10)&"#@#1")	
		writefiles("9"&Chr(10)&"#@#1")
	
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDSEC"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("SECTION"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("CLASSES"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDSEC"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("SECTION"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("TABLES"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("VPORT"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("8"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("VPORT"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("31"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbViewportTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("*ACTIVE"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("20"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("11"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("21"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("12"&Chr(10)&"#@#1")
	writefiles("209.475294253"&Chr(10)&"#@#1")
	writefiles("22"&Chr(10)&"#@#1")
	writefiles("86.0026335861"&Chr(10)&"#@#1")
	writefiles("13"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("23"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("14"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("24"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("15"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("25"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("16"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("26"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("36"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("17"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("27"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("37"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("40"&Chr(10)&"#@#1")
	writefiles("319.744231092"&Chr(10)&"#@#1")
	writefiles("41"&Chr(10)&"#@#1")
	writefiles("2.12946428571"&Chr(10)&"#@#1")
	writefiles("42"&Chr(10)&"#@#1")
	writefiles("50"&Chr(10)&"#@#1")
	writefiles("43"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("44"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("50"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("51"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("71"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("72"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("73"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("74"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("75"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("76"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("77"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("78"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("281"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("65"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("110"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("120"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("130"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("111"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("121"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("131"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("112"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("122"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("132"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("79"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("146"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("348"&Chr(10)&"#@#1")
	writefiles("10020"&Chr(10)&"#@#1")
	writefiles("60"&Chr(10)&"#@#1")
	writefiles("7"&Chr(10)&"#@#1")
	writefiles("61"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("292"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("282"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("141"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("142"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("63"&Chr(10)&"#@#1")
	writefiles("250"&Chr(10)&"#@#1")
	writefiles("421"&Chr(10)&"#@#1")
	writefiles("3358443"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("LTYPE"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("4"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("LTYPE"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("14"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbLinetypeTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("ByBlock"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles(""&Chr(10)&"#@#1")
	writefiles("72"&Chr(10)&"#@#1")
	writefiles("65"&Chr(10)&"#@#1")
	writefiles("73"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("40"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("LTYPE"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("15"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbLinetypeTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("ByLayer"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles(""&Chr(10)&"#@#1")
	writefiles("72"&Chr(10)&"#@#1")
	writefiles("65"&Chr(10)&"#@#1")
	writefiles("73"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("40"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("LTYPE"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("16"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbLinetypeTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("Continuous"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("Solid line"&Chr(10)&"#@#1")
	writefiles("72"&Chr(10)&"#@#1")
	writefiles("65"&Chr(10)&"#@#1")
	writefiles("73"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("40"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("LAYER"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("LAYER"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbLayerTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("62"&Chr(10)&"#@#1")
	writefiles("7"&Chr(10)&"#@#1")
	writefiles("6"&Chr(10)&"#@#1")
	writefiles("CONTINUOUS"&Chr(10)&"#@#1")
	writefiles("370"&Chr(10)&"#@#1")
	writefiles("-3"&Chr(10)&"#@#1")
	writefiles("390"&Chr(10)&"#@#1")
	writefiles("F"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("STYLE"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("STYLE"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("45"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbTextStyleTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("Standard"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("40"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("41"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("50"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("71"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("42"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("txt"&Chr(10)&"#@#1")
	writefiles("4"&Chr(10)&"#@#1")
	writefiles(""&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("VIEW"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("6"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("UCS"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("7"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("APPID"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("9"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("APPID"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("12"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("9"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbRegAppTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("ACAD"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("DIMSTYLE"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("A"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbDimStyleTable"&Chr(10)&"#@#1")
	writefiles("71"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("DIMSTYLE"&Chr(10)&"#@#1")
	writefiles("105"&Chr(10)&"#@#1")
	writefiles("46"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("A"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbDimStyleTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("Standard"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("40"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("41"&Chr(10)&"#@#1")
	writefiles("0.18"&Chr(10)&"#@#1")
	writefiles("42"&Chr(10)&"#@#1")
	writefiles("0.0625"&Chr(10)&"#@#1")
	writefiles("43"&Chr(10)&"#@#1")
	writefiles("0.38"&Chr(10)&"#@#1")
	writefiles("44"&Chr(10)&"#@#1")
	writefiles("0.18"&Chr(10)&"#@#1")
	writefiles("45"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("46"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("47"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("48"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("140"&Chr(10)&"#@#1")
	writefiles("0.18"&Chr(10)&"#@#1")
	writefiles("141"&Chr(10)&"#@#1")
	writefiles("0.09"&Chr(10)&"#@#1")
	writefiles("142"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("143"&Chr(10)&"#@#1")
	writefiles("25.4"&Chr(10)&"#@#1")
	writefiles("144"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("145"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("146"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("147"&Chr(10)&"#@#1")
	writefiles("0.09"&Chr(10)&"#@#1")
	writefiles("148"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("71"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("72"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("73"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("74"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("75"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("76"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("77"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("78"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("79"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("170"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("171"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("172"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("173"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("174"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("175"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("176"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("177"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("178"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("179"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("271"&Chr(10)&"#@#1")
	writefiles("4"&Chr(10)&"#@#1")
	writefiles("272"&Chr(10)&"#@#1")
	writefiles("4"&Chr(10)&"#@#1")
	writefiles("273"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("274"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("275"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("276"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("277"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("278"&Chr(10)&"#@#1")
	writefiles("46"&Chr(10)&"#@#1")
	writefiles("279"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("280"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("281"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("282"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("283"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("284"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("285"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("286"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("288"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("289"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("340"&Chr(10)&"#@#1")
	writefiles("Standard"&Chr(10)&"#@#1")
	writefiles("341"&Chr(10)&"#@#1")
	writefiles(""&Chr(10)&"#@#1")
	writefiles("371"&Chr(10)&"#@#1")
	writefiles("-2"&Chr(10)&"#@#1")
	writefiles("372"&Chr(10)&"#@#1")
	writefiles("-2"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("TABLE"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("BLOCK_RECORD"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTable"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("BLOCK_RECORD"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("1F"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbBlockTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("*Model_Space"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("280"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("281"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("BLOCK_RECORD"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("1E"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbSymbolTableRecord"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbBlockTableRecord"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("*Paper_Space"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("280"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("281"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDTAB"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDSEC"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("SECTION"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("BLOCKS"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("BLOCK"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("20"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("1F"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbEntity"&Chr(10)&"#@#1")
	writefiles("8"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbBlockBegin"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("*Model_Space"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("20"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("30"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("*Model_Space"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles(""&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDBLK"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("21"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("1F"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbEntity"&Chr(10)&"#@#1")
	writefiles("8"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbBlockEnd"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("BLOCK"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("1C"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("1B"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbEntity"&Chr(10)&"#@#1")
	writefiles("8"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbBlockBegin"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("*Paper_Space"&Chr(10)&"#@#1")
	writefiles("70"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("10"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("20"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("30"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("*Paper_Space"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles(""&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDBLK"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("1D"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("1E"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbEntity"&Chr(10)&"#@#1")
	writefiles("8"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbBlockEnd"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDSEC"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("SECTION"&Chr(10)&"#@#1")
	writefiles("2"&Chr(10)&"#@#1")
	writefiles("OBJECTS"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("DICTIONARY"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("C"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbDictionary"&Chr(10)&"#@#1")
	writefiles("281"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("3"&Chr(10)&"#@#1")
	writefiles("ACAD_GROUP"&Chr(10)&"#@#1")
	writefiles("350"&Chr(10)&"#@#1")
	writefiles("D"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("DICTIONARY"&Chr(10)&"#@#1")
	writefiles("5"&Chr(10)&"#@#1")
	writefiles("D"&Chr(10)&"#@#1")
	writefiles("330"&Chr(10)&"#@#1")
	writefiles("C"&Chr(10)&"#@#1")
	writefiles("100"&Chr(10)&"#@#1")
	writefiles("AcDbDictionary"&Chr(10)&"#@#1")
	writefiles("281"&Chr(10)&"#@#1")
	writefiles("1"&Chr(10)&"#@#1")
	writefiles("0"&Chr(10)&"#@#1")
	writefiles("ENDSEC"&Chr(10)&"#@#1")
End Function
